/* Generated by re2c 0.9.1-C on Thu Jun  5 05:41:07 2008
 */
#line 1 "./modules/parsers/gas/gas-token.re"
/*
 * GAS-compatible re2c lexer
 *
 *  Copyright (C) 2005-2007  Peter Johnson
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of other contributors
 *    may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND OTHER CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR OTHER CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
#include <util.h>
RCSID("$Id: gas-token.re 2007 2007-11-03 04:27:35Z peter $");

#include <libyasm.h>

#include "modules/parsers/gas/gas-parser.h"


#define BSIZE   8192

#define YYCURSOR        cursor
#define YYLIMIT         (s->lim)
#define YYMARKER        (s->ptr)
#define YYFILL(n)       {cursor = fill(parser_gas, cursor);}

#define RETURN(i)       do {s->cur = cursor; parser_gas->tokch = s->tok[0]; \
                         return i;} while (0)

#define SCANINIT()      {s->tok = cursor;}

#define TOK             ((char *)s->tok)
#define TOKLEN          (size_t)(cursor-s->tok)

static size_t
rept_input(yasm_parser_gas *parser_gas, /*@out@*/ YYCTYPE *buf,
           size_t max_size)
{
    gas_rept *rept = parser_gas->rept;
    size_t numleft = max_size;
    YYCTYPE *bufp = buf;

    /* If numrept is 0, copy out just the line end characters */
    if (rept->numrept == 0) {
        /* Skip first line, which contains .line */
        rept->line = STAILQ_NEXT(rept->line, link);
        if (!rept->line) {
            rept->numrept = 1;
            rept->numdone = 1;
        }
        while (rept->numrept == 0 && numleft > 0) {
            *bufp++ = rept->line->data[rept->line->len-1];
            rept->line = STAILQ_NEXT(rept->line, link);
            if (!rept->line) {
                rept->numrept = 1;
                rept->numdone = 1;
            }
        }
    }

    /* Copy out the previous fill buffer until we're *really* done */
    if (rept->numdone == rept->numrept) {
        size_t numcopy = rept->oldbuflen - rept->oldbufpos;
        if (numcopy > numleft)
            numcopy = numleft;
        memcpy(bufp, &rept->oldbuf[rept->oldbufpos], numcopy);
        numleft -= numcopy;
        bufp += numcopy;
        rept->oldbufpos += numcopy;

        if (rept->oldbufpos == rept->oldbuflen) {
            /* Delete lines, then delete rept and clear rept state */
            gas_rept_line *cur, *next;
            cur = STAILQ_FIRST(&rept->lines);
            while (cur) {
                next = STAILQ_NEXT(cur, link);
                yasm_xfree(cur->data);
                yasm_xfree(cur);
                cur = next;
            }
            yasm_xfree(rept->oldbuf);
            yasm_xfree(rept);
            parser_gas->rept = NULL;
        }
    }

    while (numleft > 0 && rept->numdone < rept->numrept) {
        /* Copy from line data to buf */
        size_t numcopy = rept->line->len - rept->linepos;
        if (numcopy > numleft)
            numcopy = numleft;
        memcpy(bufp, &rept->line->data[rept->linepos], numcopy);
        numleft -= numcopy;
        bufp += numcopy;
        rept->linepos += numcopy;

        /* Update locations if needed */
        if (rept->linepos == rept->line->len) {
            rept->line = STAILQ_NEXT(rept->line, link);
            rept->linepos = 0;
        }
        if (rept->line == NULL) {
            rept->numdone++;
            rept->line = STAILQ_FIRST(&rept->lines);
        }
    }

    return (max_size-numleft);
}

/* Bridge function to convert byte-oriented parser with line-oriented
 * preprocessor.
 */
static size_t
preproc_input(yasm_parser_gas *parser_gas, /*@out@*/ YYCTYPE *buf,
              size_t max_size)
{
    size_t tot=0;
    while (max_size > 0) {
        size_t n;

        if (!parser_gas->line) {
            parser_gas->line = yasm_preproc_get_line(parser_gas->preproc);
            if (!parser_gas->line)
                return tot; /* EOF */
            parser_gas->linepos = parser_gas->line;
            parser_gas->lineleft = strlen(parser_gas->line) + 1;
            parser_gas->line[parser_gas->lineleft-1] = '\n';
        }

        n = parser_gas->lineleft<max_size ? parser_gas->lineleft : max_size;
        strncpy((char *)buf+tot, parser_gas->linepos, n);

        if (n == parser_gas->lineleft) {
            yasm_xfree(parser_gas->line);
            parser_gas->line = NULL;
        } else {
            parser_gas->lineleft -= n;
            parser_gas->linepos += n;
        }

        tot += n;
        max_size -= n;
    }
    return tot;
}
#if 0
static size_t
fill_input(void *d, unsigned char *buf, size_t max)
{
    return yasm_preproc_input((yasm_preproc *)d, (char *)buf, max);
}
#endif
static YYCTYPE *
fill(yasm_parser_gas *parser_gas, YYCTYPE *cursor)
{
    yasm_scanner *s = &parser_gas->s;
    int first = 0;
    if(!s->eof){
        size_t cnt = s->tok - s->bot;
        if(cnt){
            memmove(s->bot, s->tok, (size_t)(s->lim - s->tok));
            s->tok = s->bot;
            s->ptr -= cnt;
            cursor -= cnt;
            s->lim -= cnt;
        }
        if (!s->bot)
            first = 1;
        if((s->top - s->lim) < BSIZE){
            YYCTYPE *buf = yasm_xmalloc((size_t)(s->lim - s->bot) + BSIZE);
            memcpy(buf, s->tok, (size_t)(s->lim - s->tok));
            s->tok = buf;
            s->ptr = &buf[s->ptr - s->bot];
            cursor = &buf[cursor - s->bot];
            s->lim = &buf[s->lim - s->bot];
            s->top = &s->lim[BSIZE];
            if (s->bot)
                yasm_xfree(s->bot);
            s->bot = buf;
        }
        if (parser_gas->rept && parser_gas->rept->ended) {
            /* Pull from rept lines instead of preproc */
            cnt = rept_input(parser_gas, s->lim, BSIZE);
        } else if((cnt = preproc_input(parser_gas, s->lim, BSIZE)) == 0) {
            s->eof = &s->lim[cnt]; *s->eof++ = '\n';
        }
        s->lim += cnt;
        if (first && parser_gas->save_input) {
            int i;
            YYCTYPE *saveline;
            parser_gas->save_last ^= 1;
            saveline = parser_gas->save_line[parser_gas->save_last];
            /* save next line into cur_line */
            for (i=0; i<79 && &s->tok[i] < s->lim && s->tok[i] != '\n'; i++)
                saveline[i] = s->tok[i];
            saveline[i] = '\0';
        }
    }
    return cursor;
}

static YYCTYPE *
save_line(yasm_parser_gas *parser_gas, YYCTYPE *cursor)
{
    yasm_scanner *s = &parser_gas->s;
    int i = 0;
    YYCTYPE *saveline;

    parser_gas->save_last ^= 1;
    saveline = parser_gas->save_line[parser_gas->save_last];

    /* save next line into cur_line */
    if ((YYLIMIT - YYCURSOR) < 80)
        YYFILL(80);
    for (i=0; i<79 && &cursor[i] < s->lim && cursor[i] != '\n'; i++)
        saveline[i] = cursor[i];
    saveline[i] = '\0';
    return cursor;
}

/* starting size of string buffer */
#define STRBUF_ALLOC_SIZE       128

/* string buffer used when parsing strings/character constants */
static YYCTYPE *strbuf = NULL;

/* length of strbuf (including terminating NULL character) */
static size_t strbuf_size = 0;

static void
strbuf_append(size_t count, YYCTYPE *cursor, yasm_scanner *s, int ch)
{
    if (count >= strbuf_size) {
        strbuf = yasm_xrealloc(strbuf, strbuf_size + STRBUF_ALLOC_SIZE);
        strbuf_size += STRBUF_ALLOC_SIZE;
    }
    strbuf[count] = ch;
}

#line 268 "./modules/parsers/gas/gas-token.re"



int
gas_parser_lex(YYSTYPE *lvalp, yasm_parser_gas *parser_gas)
{
    /*@null@*/ gas_rept *rept = parser_gas->rept;
    yasm_scanner *s = &parser_gas->s;
    YYCTYPE *cursor = s->cur;
    size_t count;
    YYCTYPE savech;
    int linestart;
    gas_rept_line *new_line;

    /* Handle one token of lookahead */
    if (parser_gas->peek_token != NONE) {
        int tok = parser_gas->peek_token;
        *lvalp = parser_gas->peek_tokval;  /* structure copy */
        parser_gas->tokch = parser_gas->peek_tokch;
        parser_gas->peek_token = NONE;
        return tok;
    }

    /* Catch EOF */
    if (s->eof && cursor == s->eof)
        return 0;

    /* Handle rept */
    if (rept && !rept->ended)
        goto rept_directive;

    /* Jump to proper "exclusive" states */
    switch (parser_gas->state) {
        case COMMENT:
            goto comment;
        case SECTION_DIRECTIVE:
            goto section_directive;
        default:
            break;
    }

scan:
    SCANINIT();

    {
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   2,   0,   0,   0,   2,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  2,   0,   0,   0,   4,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   4,   0, 
	252, 252, 124, 124, 124, 124, 124, 124, 
	 92,  92,   0,   0,   0,   0,   0,   0, 
	  0,  76,  76,  76,  76,  76,  76,  12, 
	 12,  12,  12,  12,  12,  12,  12,  12, 
	 12,  12,  12,  12,  12,  12,  12,  12, 
	 12,  12,  12,   0,   0,   0,   0,   4, 
	  0,  76,  76,  76,  76,  76,  76,  12, 
	 12,  12,  12,  12,  12,  12,  12,  12, 
	 12,  12,  12,  12,  12,  12,  12,  12, 
	 12,  12,  12,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	};

#line 343 "gas-token.c"
{
	YYCTYPE yych;
	unsigned int yyaccept;
	goto yy0;
	++YYCURSOR;
yy0:
	if((YYLIMIT - YYCURSOR) < 5) YYFILL(5);
	yych = *YYCURSOR;
	if(yych <= '0'){
		if(yych <= '"'){
			if(yych <= '\f'){
				if(yych <= '\b')	goto yy30;
				if(yych <= '\t')	goto yy26;
				if(yych <= '\n')	goto yy28;
				goto yy30;
			} else {
				if(yych <= '\037'){
					if(yych <= '\r')	goto yy26;
					goto yy30;
				} else {
					if(yych <= ' ')	goto yy26;
					if(yych <= '!')	goto yy13;
					goto yy7;
				}
			}
		} else {
			if(yych <= '&'){
				if(yych <= '#')	goto yy24;
				if(yych == '%')	goto yy20;
				goto yy13;
			} else {
				if(yych <= '-'){
					if(yych <= '\'')	goto yy5;
					goto yy13;
				} else {
					if(yych <= '.')	goto yy18;
					if(yych <= '/')	goto yy15;
					goto yy2;
				}
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '<'){
				if(yych <= '9')	goto yy4;
				if(yych <= ':')	goto yy13;
				if(yych <= ';')	goto yy16;
				goto yy9;
			} else {
				if(yych <= '>'){
					if(yych <= '=')	goto yy13;
					goto yy11;
				} else {
					if(yych <= '?')	goto yy30;
					if(yych <= '@')	goto yy13;
					goto yy22;
				}
			}
		} else {
			if(yych <= 'z'){
				if(yych <= '^'){
					if(yych <= ']')	goto yy30;
					goto yy13;
				} else {
					if(yych <= '_')	goto yy18;
					if(yych <= '`')	goto yy30;
					goto yy22;
				}
			} else {
				if(yych <= '|'){
					if(yych <= '{')	goto yy30;
					goto yy13;
				} else {
					if(yych == '~')	goto yy13;
					goto yy30;
				}
			}
		}
	}
yy2:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 32) {
		goto yy64;
	}
	if(yych <= 'W'){
		if(yych <= 'C'){
			if(yych <= ':'){
				if(yych >= ':')	goto yy55;
				goto yy3;
			} else {
				if(yych == 'B')	goto yy59;
				goto yy3;
			}
		} else {
			if(yych <= 'F'){
				if(yych <= 'E')	goto yy62;
				goto yy60;
			} else {
				if(yych == 'T')	goto yy62;
				goto yy3;
			}
		}
	} else {
		if(yych <= 'e'){
			if(yych <= 'a'){
				if(yych <= 'X')	goto yy63;
				goto yy3;
			} else {
				if(yych <= 'b')	goto yy59;
				if(yych >= 'd')	goto yy62;
				goto yy3;
			}
		} else {
			if(yych <= 't'){
				if(yych <= 'f')	goto yy60;
				if(yych >= 't')	goto yy62;
				goto yy3;
			} else {
				if(yych == 'x')	goto yy63;
				goto yy3;
			}
		}
	}
yy3:
#line 314 "./modules/parsers/gas/gas-token.re"
{
            savech = s->tok[TOKLEN];
            s->tok[TOKLEN] = '\0';
            lvalp->intn = yasm_intnum_create_dec(TOK);
            s->tok[TOKLEN] = savech;
            RETURN(INTNUM);
        }
#line 476 "gas-token.c"
yy4:	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ':'){
			if(yych <= '9')	goto yy58;
			goto yy55;
		} else {
			if(yych == 'B')	goto yy51;
			goto yy58;
		}
	} else {
		if(yych <= 'b'){
			if(yych <= 'F')	goto yy53;
			if(yych <= 'a')	goto yy58;
			goto yy51;
		} else {
			if(yych == 'f')	goto yy53;
			goto yy58;
		}
	}
yy5:	yych = *++YYCURSOR;
	goto yy6;
yy6:
#line 360 "./modules/parsers/gas/gas-token.re"
{
            goto charconst;
        }
#line 503 "gas-token.c"
yy7:	yych = *++YYCURSOR;
	goto yy8;
yy8:
#line 365 "./modules/parsers/gas/gas-token.re"
{
            goto stringconst;
        }
#line 511 "gas-token.c"
yy9:	yych = *++YYCURSOR;
	if(yych == '<')	goto yy49;
	goto yy10;
yy10:
#line 372 "./modules/parsers/gas/gas-token.re"
{ RETURN(LEFT_OP); }
#line 518 "gas-token.c"
yy11:	yych = *++YYCURSOR;
	if(yych == '>')	goto yy47;
	goto yy12;
yy12:
#line 373 "./modules/parsers/gas/gas-token.re"
{ RETURN(RIGHT_OP); }
#line 525 "gas-token.c"
yy13:	yych = *++YYCURSOR;
	goto yy14;
yy14:
#line 374 "./modules/parsers/gas/gas-token.re"
{ RETURN(s->tok[0]); }
#line 531 "gas-token.c"
yy15:	yych = *++YYCURSOR;
	if(yych == '*')	goto yy45;
	goto yy14;
yy16:	yych = *++YYCURSOR;
	goto yy17;
yy17:
#line 375 "./modules/parsers/gas/gas-token.re"
{
            parser_gas->state = INITIAL;
            RETURN(s->tok[0]);
        }
#line 543 "gas-token.c"
yy18:	yych = *++YYCURSOR;
	goto yy44;
yy19:
#line 381 "./modules/parsers/gas/gas-token.re"
{
            lvalp->str_val = yasm__xstrndup(TOK, TOKLEN);
            RETURN(ID);
        }
#line 552 "gas-token.c"
yy20:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 8) {
		goto yy40;
	}
	goto yy21;
yy21:
#line 502 "./modules/parsers/gas/gas-token.re"
{
            yasm_warn_set(YASM_WARN_UNREC_CHAR,
                          N_("ignoring unrecognized character `%s'"),
                          yasm__conv_unprint(s->tok[0]));
            goto scan;
        }
#line 566 "gas-token.c"
yy22:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 4) {
		goto yy33;
	}
	if(yych <= '\r'){
		if(yych == '\t')	goto yy35;
		if(yych >= '\r')	goto yy35;
		goto yy23;
	} else {
		if(yych <= ' '){
			if(yych >= ' ')	goto yy35;
			goto yy23;
		} else {
			if(yych == ':')	goto yy38;
			goto yy23;
		}
	}
yy23:
#line 453 "./modules/parsers/gas/gas-token.re"
{
            /* Can only be an instruction/prefix when not inside an
             * instruction or directive.
             */
            if (parser_gas->state != INSTDIR) {
                uintptr_t prefix;
                savech = s->tok[TOKLEN];
                s->tok[TOKLEN] = '\0';
                switch (yasm_arch_parse_check_insnprefix
                        (p_object->arch, TOK, TOKLEN, cur_line, &lvalp->bc,
                         &prefix)) {
                    case YASM_ARCH_INSN:
                        s->tok[TOKLEN] = savech;
                        parser_gas->state = INSTDIR;
                        RETURN(INSN);
                    case YASM_ARCH_PREFIX:
                        lvalp->arch_data = prefix;
                        s->tok[TOKLEN] = savech;
                        RETURN(PREFIX);
                    default:
                        s->tok[TOKLEN] = savech;
                }
            }
            /* Propagate errors in case we got a warning from the arch */
            yasm_errwarn_propagate(parser_gas->errwarns, cur_line);
            /* Just an identifier, return as such. */
            lvalp->str_val = yasm__xstrndup(TOK, TOKLEN);
            RETURN(ID);
        }
#line 616 "gas-token.c"
yy24:	yych = *++YYCURSOR;
	goto yy25;
yy25:
#line 484 "./modules/parsers/gas/gas-token.re"
{
            if (strcmp(((yasm_preproc_base*)parser_gas->preproc)->module->keyword,
                 "cpp") == 0)
            {
                RETURN(LINE_MARKER);
            } else
                goto line_comment;
        }
#line 629 "gas-token.c"
yy26:	yych = *++YYCURSOR;
	goto yy32;
yy27:
#line 493 "./modules/parsers/gas/gas-token.re"
{ goto scan; }
#line 635 "gas-token.c"
yy28:	yych = *++YYCURSOR;
	goto yy29;
yy29:
#line 495 "./modules/parsers/gas/gas-token.re"
{
            if (parser_gas->save_input)
                cursor = save_line(parser_gas, cursor);
            parser_gas->state = INITIAL;
            RETURN(s->tok[0]);
        }
#line 646 "gas-token.c"
yy30:	yych = *++YYCURSOR;
	goto yy21;
yy31:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy32;
yy32:	if(yybm[0+yych] & 2) {
		goto yy31;
	}
	goto yy27;
yy33:	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy34;
yy34:	if(yybm[0+yych] & 4) {
		goto yy33;
	}
	if(yych <= '\r'){
		if(yych == '\t')	goto yy35;
		if(yych <= '\f')	goto yy23;
		goto yy35;
	} else {
		if(yych <= ' '){
			if(yych <= '\037')	goto yy23;
			goto yy35;
		} else {
			if(yych == ':')	goto yy38;
			goto yy23;
		}
	}
yy35:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy36;
yy36:	if(yych <= '\r'){
		if(yych == '\t')	goto yy35;
		if(yych >= '\r')	goto yy35;
		goto yy37;
	} else {
		if(yych <= ' '){
			if(yych >= ' ')	goto yy35;
			goto yy37;
		} else {
			if(yych == ':')	goto yy38;
			goto yy37;
		}
	}
yy37:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 0:	goto yy3;
	case 2:	goto yy61;
	case 1:	goto yy23;
	}
yy38:	yych = *++YYCURSOR;
	goto yy39;
yy39:
#line 412 "./modules/parsers/gas/gas-token.re"
{
            /* strip off colon and any whitespace */
            count = TOKLEN-1;
            while (s->tok[count] == ' ' || s->tok[count] == '\t'
                   || s->tok[count] == '\r')
                count--;
            /* Just an identifier, return as such. */
            lvalp->str_val = yasm__xstrndup(TOK, count);
            RETURN(LABEL);
        }
#line 715 "gas-token.c"
yy40:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy41;
yy41:	if(yybm[0+yych] & 8) {
		goto yy40;
	}
	goto yy42;
yy42:
#line 387 "./modules/parsers/gas/gas-token.re"
{
            savech = s->tok[TOKLEN];
            s->tok[TOKLEN] = '\0';
            switch (yasm_arch_parse_check_regtmod
                    (p_object->arch, TOK+1, TOKLEN-1, &lvalp->arch_data)) {
                case YASM_ARCH_REG:
                    s->tok[TOKLEN] = savech;
                    RETURN(REG);
                case YASM_ARCH_REGGROUP:
                    s->tok[TOKLEN] = savech;
                    RETURN(REGGROUP);
                case YASM_ARCH_SEGREG:
                    s->tok[TOKLEN] = savech;
                    RETURN(SEGREG);
                default:
                    break;
            }
            yasm_error_set(YASM_ERROR_GENERAL,
                           N_("Unrecognized register name `%s'"), s->tok);
            s->tok[TOKLEN] = savech;
            lvalp->arch_data = 0;
            RETURN(REG);
        }
#line 749 "gas-token.c"
yy43:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy44;
yy44:	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy43;
			goto yy19;
		} else {
			if(yych == '/')	goto yy19;
			goto yy43;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy19;
			if(yych <= 'Z')	goto yy43;
			goto yy19;
		} else {
			if(yych == '`')	goto yy19;
			if(yych <= 'z')	goto yy43;
			goto yy19;
		}
	}
yy45:	yych = *++YYCURSOR;
	goto yy46;
yy46:
#line 483 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = COMMENT; goto comment; }
#line 778 "gas-token.c"
yy47:	yych = *++YYCURSOR;
	goto yy48;
yy48:
#line 371 "./modules/parsers/gas/gas-token.re"
{ RETURN(RIGHT_OP); }
#line 784 "gas-token.c"
yy49:	yych = *++YYCURSOR;
	goto yy50;
yy50:
#line 370 "./modules/parsers/gas/gas-token.re"
{ RETURN(LEFT_OP); }
#line 790 "gas-token.c"
yy51:	yych = *++YYCURSOR;
	goto yy52;
yy52:
#line 444 "./modules/parsers/gas/gas-token.re"
{
            /* build local label name */
            lvalp->str_val = yasm_xmalloc(30);
            sprintf(lvalp->str_val, "L%c\001%lu", s->tok[0],
                    parser_gas->local[s->tok[0]-'0']);
            RETURN(ID);
        }
#line 802 "gas-token.c"
yy53:	yych = *++YYCURSOR;
	goto yy54;
yy54:
#line 435 "./modules/parsers/gas/gas-token.re"
{
            /* build local label name */
            lvalp->str_val = yasm_xmalloc(30);
            sprintf(lvalp->str_val, "L%c\001%lu", s->tok[0],
                    parser_gas->local[s->tok[0]-'0']+1);
            RETURN(ID);
        }
#line 814 "gas-token.c"
yy55:	yych = *++YYCURSOR;
	goto yy56;
yy56:
#line 424 "./modules/parsers/gas/gas-token.re"
{
            /* increment label index */
            parser_gas->local[s->tok[0]-'0']++;
            /* build local label name */
            lvalp->str_val = yasm_xmalloc(30);
            sprintf(lvalp->str_val, "L%c\001%lu", s->tok[0],
                    parser_gas->local[s->tok[0]-'0']);
            RETURN(LABEL);
        }
#line 828 "gas-token.c"
yy57:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy58;
yy58:	if(yybm[0+yych] & 16) {
		goto yy57;
	}
	goto yy3;
yy59:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 128) {
		goto yy78;
	}
	goto yy52;
yy60:	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '+')	goto yy70;
	if(yych == '-')	goto yy70;
	goto yy71;
yy61:
#line 351 "./modules/parsers/gas/gas-token.re"
{
            savech = s->tok[TOKLEN];
            s->tok[TOKLEN] = '\0';
            lvalp->flt = yasm_floatnum_create(TOK+2);
            s->tok[TOKLEN] = savech;
            RETURN(FLTNUM);
        }
#line 856 "gas-token.c"
yy62:	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '+')	goto yy70;
	if(yych == '-')	goto yy70;
	goto yy71;
yy63:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 64) {
		goto yy67;
	}
	goto yy37;
yy64:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy65;
yy65:	if(yybm[0+yych] & 32) {
		goto yy64;
	}
	goto yy66;
yy66:
#line 332 "./modules/parsers/gas/gas-token.re"
{
            savech = s->tok[TOKLEN];
            s->tok[TOKLEN] = '\0';
            lvalp->intn = yasm_intnum_create_oct(TOK);
            s->tok[TOKLEN] = savech;
            RETURN(INTNUM);
        }
#line 884 "gas-token.c"
yy67:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy68;
yy68:	if(yybm[0+yych] & 64) {
		goto yy67;
	}
	goto yy69;
yy69:
#line 341 "./modules/parsers/gas/gas-token.re"
{
            savech = s->tok[TOKLEN];
            s->tok[TOKLEN] = '\0';
            /* skip 0 and x */
            lvalp->intn = yasm_intnum_create_hex(TOK+2);
            s->tok[TOKLEN] = savech;
            RETURN(INTNUM);
        }
#line 903 "gas-token.c"
yy70:	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	goto yy71;
yy71:	if(yych <= '9'){
		if(yych == '.')	goto yy72;
		if(yych <= '/')	goto yy61;
		goto yy70;
	} else {
		if(yych <= 'E'){
			if(yych <= 'D')	goto yy61;
			goto yy74;
		} else {
			if(yych == 'e')	goto yy74;
			goto yy61;
		}
	}
yy72:	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	goto yy73;
yy73:	if(yych <= 'D'){
		if(yych <= '/')	goto yy61;
		if(yych <= '9')	goto yy72;
		goto yy61;
	} else {
		if(yych <= 'E')	goto yy74;
		if(yych != 'e')	goto yy61;
		goto yy74;
	}
yy74:	yych = *++YYCURSOR;
	if(yych <= ','){
		if(yych != '+')	goto yy37;
		goto yy75;
	} else {
		if(yych <= '-')	goto yy75;
		if(yych <= '/')	goto yy37;
		if(yych <= '9')	goto yy76;
		goto yy37;
	}
yy75:	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy37;
	if(yych >= ':')	goto yy37;
	goto yy76;
yy76:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy77;
yy77:	if(yych <= '/')	goto yy61;
	if(yych <= '9')	goto yy76;
	goto yy61;
yy78:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy79;
yy79:	if(yybm[0+yych] & 128) {
		goto yy78;
	}
	goto yy80;
yy80:
#line 323 "./modules/parsers/gas/gas-token.re"
{
            savech = s->tok[TOKLEN];
            s->tok[TOKLEN] = '\0';
            lvalp->intn = yasm_intnum_create_bin(TOK+2);
            s->tok[TOKLEN] = savech;
            RETURN(INTNUM);
        }
#line 974 "gas-token.c"
}
}
#line 508 "./modules/parsers/gas/gas-token.re"


    /* C-style comment; nesting not supported */
comment:
    SCANINIT();

    {

#line 986 "gas-token.c"
{
	YYCTYPE yych;
	goto yy81;
	++YYCURSOR;
yy81:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych == '\n')	goto yy85;
	if(yych != '*')	goto yy87;
	goto yy83;
yy83:	yych = *++YYCURSOR;
	if(yych == '/')	goto yy88;
	goto yy84;
yy84:
#line 524 "./modules/parsers/gas/gas-token.re"
{
            if (cursor == s->eof)
                return 0;
            goto comment;
        }
#line 1007 "gas-token.c"
yy85:	yych = *++YYCURSOR;
	goto yy86;
yy86:
#line 518 "./modules/parsers/gas/gas-token.re"
{
            if (parser_gas->save_input)
                cursor = save_line(parser_gas, cursor);
            RETURN(s->tok[0]);
        }
#line 1017 "gas-token.c"
yy87:	yych = *++YYCURSOR;
	goto yy84;
yy88:	yych = *++YYCURSOR;
	goto yy89;
yy89:
#line 516 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INITIAL; goto scan; }
#line 1025 "gas-token.c"
}
}
#line 529 "./modules/parsers/gas/gas-token.re"


    /* Single line comment. */
line_comment:
    {
	static unsigned char yybm[] = {
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128,   0, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	};

#line 1069 "gas-token.c"
{
	YYCTYPE yych;
	goto yy90;
yy91:	++YYCURSOR;
yy90:
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy92;
yy92:	if(yybm[0+yych] & 128) {
		goto yy91;
	}
	goto yy93;
yy93:
#line 534 "./modules/parsers/gas/gas-token.re"
{ goto scan; }
#line 1085 "gas-token.c"
}
}
#line 535 "./modules/parsers/gas/gas-token.re"


    /* .section directive (the section name portion thereof) */
section_directive:
    SCANINIT();

    {
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,  64,   0,   0,   0,  64,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	 64,   0,   0,   0, 128,   0,   0,   0, 
	  0,   0,   0,   0,   0, 128, 128,   0, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128,   0,   0,   0,   0,   0,   0, 
	  0, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128,   0,   0,   0,   0, 128, 
	  0, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	};

#line 1131 "gas-token.c"
{
	YYCTYPE yych;
	goto yy94;
	++YYCURSOR;
yy94:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych <= '$'){
		if(yych <= '\r'){
			if(yych <= '\t'){
				if(yych <= '\b')	goto yy106;
				goto yy100;
			} else {
				if(yych <= '\n')	goto yy104;
				if(yych <= '\f')	goto yy106;
				goto yy100;
			}
		} else {
			if(yych <= '!'){
				if(yych == ' ')	goto yy100;
				goto yy106;
			} else {
				if(yych <= '"')	goto yy98;
				if(yych <= '#')	goto yy106;
				goto yy96;
			}
		}
	} else {
		if(yych <= '@'){
			if(yych <= '.'){
				if(yych <= '+')	goto yy106;
				if(yych <= ',')	goto yy102;
				goto yy96;
			} else {
				if(yych <= '/')	goto yy106;
				if(yych >= ':')	goto yy106;
				goto yy96;
			}
		} else {
			if(yych <= '_'){
				if(yych <= 'Z')	goto yy96;
				if(yych <= '^')	goto yy106;
				goto yy96;
			} else {
				if(yych <= '`')	goto yy106;
				if(yych >= '{')	goto yy106;
				goto yy96;
			}
		}
	}
yy96:	yych = *++YYCURSOR;
	goto yy111;
yy97:
#line 542 "./modules/parsers/gas/gas-token.re"
{
            lvalp->str_val = yasm__xstrndup(TOK, TOKLEN);
            parser_gas->state = INITIAL;
            RETURN(ID);
        }
#line 1191 "gas-token.c"
yy98:	yych = *++YYCURSOR;
	goto yy99;
yy99:
#line 548 "./modules/parsers/gas/gas-token.re"
{ goto stringconst; }
#line 1197 "gas-token.c"
yy100:	yych = *++YYCURSOR;
	goto yy109;
yy101:
#line 550 "./modules/parsers/gas/gas-token.re"
{ goto section_directive; }
#line 1203 "gas-token.c"
yy102:	yych = *++YYCURSOR;
	goto yy103;
yy103:
#line 552 "./modules/parsers/gas/gas-token.re"
{
            parser_gas->state = INITIAL;
            RETURN(s->tok[0]);
        }
#line 1212 "gas-token.c"
yy104:	yych = *++YYCURSOR;
	goto yy105;
yy105:
#line 557 "./modules/parsers/gas/gas-token.re"
{
            if (parser_gas->save_input)
                cursor = save_line(parser_gas, cursor);
            parser_gas->state = INITIAL;
            RETURN(s->tok[0]);
        }
#line 1223 "gas-token.c"
yy106:	yych = *++YYCURSOR;
	goto yy107;
yy107:
#line 564 "./modules/parsers/gas/gas-token.re"
{
            yasm_warn_set(YASM_WARN_UNREC_CHAR,
                          N_("ignoring unrecognized character `%s'"),
                          yasm__conv_unprint(s->tok[0]));
            goto section_directive;
        }
#line 1234 "gas-token.c"
yy108:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy109;
yy109:	if(yybm[0+yych] & 64) {
		goto yy108;
	}
	goto yy101;
yy110:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy111;
yy111:	if(yybm[0+yych] & 128) {
		goto yy110;
	}
	goto yy97;
}
}
#line 570 "./modules/parsers/gas/gas-token.re"


    /* character constant values */
charconst:
    /*TODO*/

    /* string constant values */
stringconst:
    strbuf = yasm_xmalloc(STRBUF_ALLOC_SIZE);
    strbuf_size = STRBUF_ALLOC_SIZE;
    count = 0;

stringconst_scan:
    SCANINIT();

    {

#line 1271 "gas-token.c"
{
	YYCTYPE yych;
	goto yy112;
	++YYCURSOR;
yy112:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych == '"')	goto yy116;
	if(yych != '\\')	goto yy118;
	goto yy114;
yy114:	yych = *++YYCURSOR;
	if(yych == '"')	goto yy119;
	goto yy115;
yy115:
#line 607 "./modules/parsers/gas/gas-token.re"
{
            if (cursor == s->eof) {
                yasm_error_set(YASM_ERROR_SYNTAX,
                               N_("unexpected end of file in string"));
                lvalp->str.contents = (char *)strbuf;
                lvalp->str.len = count;
                RETURN(STRING);
            }
            strbuf_append(count++, cursor, s, s->tok[0]);
            goto stringconst_scan;
        }
#line 1298 "gas-token.c"
yy116:	yych = *++YYCURSOR;
	goto yy117;
yy117:
#line 599 "./modules/parsers/gas/gas-token.re"
{
            strbuf_append(count, cursor, s, '\0');
            yasm_unescape_cstring(strbuf, &count);
            lvalp->str.contents = (char *)strbuf;
            lvalp->str.len = count;
            RETURN(STRING);
        }
#line 1310 "gas-token.c"
yy118:	yych = *++YYCURSOR;
	goto yy115;
yy119:	yych = *++YYCURSOR;
	goto yy120;
yy120:
#line 587 "./modules/parsers/gas/gas-token.re"
{
            if (cursor == s->eof) {
                yasm_error_set(YASM_ERROR_SYNTAX,
                               N_("unexpected end of file in string"));
                lvalp->str.contents = (char *)strbuf;
                lvalp->str.len = count;
                RETURN(STRING);
            }
            strbuf_append(count++, cursor, s, '"');
            goto stringconst_scan;
        }
#line 1328 "gas-token.c"
}
}
#line 618 "./modules/parsers/gas/gas-token.re"


rept_directive:
    strbuf = yasm_xmalloc(STRBUF_ALLOC_SIZE);
    strbuf_size = STRBUF_ALLOC_SIZE;
    count = 0;
    linestart = 1;


rept_scan:
    SCANINIT();

    {

#line 1346 "gas-token.c"
{
	YYCTYPE yych;
	unsigned int yyaccept;
	goto yy121;
	++YYCURSOR;
yy121:
	if((YYLIMIT - YYCURSOR) < 5) YYFILL(5);
	yych = *YYCURSOR;
	if(yych <= '-'){
		if(yych != '\n')	goto yy127;
		goto yy123;
	} else {
		if(yych <= '.')	goto yy125;
		if(yych != ';')	goto yy127;
		goto yy123;
	}
yy123:	yych = *++YYCURSOR;
	goto yy124;
yy124:
#line 631 "./modules/parsers/gas/gas-token.re"
{
            /* Line ending, save in lines */
            new_line = yasm_xmalloc(sizeof(gas_rept_line));
            if (cursor == s->eof) {
                yasm_xfree(strbuf);
                return 0;
            }
            strbuf_append(count++, cursor, s, s->tok[0]);
            new_line->data = strbuf;
            new_line->len = count;
            STAILQ_INSERT_TAIL(&rept->lines, new_line, link);
            /* Allocate new strbuf */
            strbuf = yasm_xmalloc(STRBUF_ALLOC_SIZE);
            strbuf_size = STRBUF_ALLOC_SIZE;
            count = 0;
            /* Mark start of line */
            linestart = 1;
            goto rept_scan;
        }
#line 1386 "gas-token.c"
yy125:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'R'){
		if(yych == 'E')	goto yy128;
		if(yych >= 'R')	goto yy130;
		goto yy126;
	} else {
		if(yych <= 'e'){
			if(yych >= 'e')	goto yy128;
			goto yy126;
		} else {
			if(yych == 'r')	goto yy130;
			goto yy126;
		}
	}
yy126:
#line 710 "./modules/parsers/gas/gas-token.re"
{
            if (cursor == s->eof) {
                yasm_xfree(strbuf);
                return 0;
            }
            strbuf_append(count++, cursor, s, s->tok[0]);
            linestart = 0;
            goto rept_scan;
        }
#line 1413 "gas-token.c"
yy127:	yych = *++YYCURSOR;
	goto yy126;
yy128:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy135;
	if(yych == 'n')	goto yy135;
	goto yy129;
yy129:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 0:	goto yy126;
	}
yy130:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy131;
	if(yych != 'e')	goto yy129;
	goto yy131;
yy131:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy132;
	if(yych != 'p')	goto yy129;
	goto yy132;
yy132:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy133;
	if(yych != 't')	goto yy129;
	goto yy133;
yy133:	yych = *++YYCURSOR;
	goto yy134;
yy134:
#line 650 "./modules/parsers/gas/gas-token.re"
{
            int i;
            if (linestart) {
                /* We don't support nested right now, error */
                yasm_error_set(YASM_ERROR_GENERAL,
                               N_("nested rept not supported"));
                yasm_errwarn_propagate(parser_gas->errwarns, cur_line);
            }
            for (i=0; i<6; i++)
                strbuf_append(count++, cursor, s, s->tok[i]);
            goto rept_scan;
        }
#line 1452 "gas-token.c"
yy135:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy136;
	if(yych != 'd')	goto yy129;
	goto yy136;
yy136:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy137;
	if(yych != 'r')	goto yy129;
	goto yy137;
yy137:	yych = *++YYCURSOR;
	goto yy138;
yy138:
#line 662 "./modules/parsers/gas/gas-token.re"
{
            if (linestart) {
                /* We're done, kick off the main lexer */
                rept->line = STAILQ_FIRST(&rept->lines);
                if (!rept->line) {
                    /* Didn't get any intervening data?  Empty repeat, so
                     * don't even bother.
                     */
                    yasm_xfree(strbuf);
                    yasm_xfree(rept);
                    parser_gas->rept = NULL;
                } else {
                    rept->ended = 1;

                    /* Add .line as first line to get line numbers correct */
                    new_line = yasm_xmalloc(sizeof(gas_rept_line));
                    new_line->data = yasm_xmalloc(40);
                    sprintf((char *)new_line->data, ".line %lu;",
                            rept->startline+1);
                    new_line->len = strlen((char *)new_line->data);
                    STAILQ_INSERT_HEAD(&rept->lines, new_line, link);

                    /* Save previous fill buffer */
                    rept->oldbuf = parser_gas->s.bot;
                    rept->oldbuflen = s->lim - s->bot;
                    rept->oldbufpos = cursor - s->bot;

                    /* Reset fill */
                    s->bot = NULL;
                    s->tok = NULL;
                    s->ptr = NULL;
                    s->cur = NULL;
                    s->lim = NULL;
                    s->top = NULL;
                    s->eof = NULL;
                    cursor = NULL;
                    YYFILL(1);
                }

                goto scan;
            } else {
                int i;
                for (i=0; i<6; i++)
                    strbuf_append(count++, cursor, s, s->tok[i]);
                goto rept_scan;
            }
        }
#line 1512 "gas-token.c"
}
}
#line 719 "./modules/parsers/gas/gas-token.re"


}
