/* Generated by re2c 0.9.1-C on Thu Jun  5 05:41:07 2008
 */
#line 1 "./modules/parsers/nasm/nasm-token.re"
/*
 * NASM-compatible re2c lexer
 *
 *  Copyright (C) 2001-2007  Peter Johnson
 *
 *  Portions based on re2c's example code.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND OTHER CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR OTHER CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
#include <util.h>
RCSID("$Id: nasm-token.re 2065 2008-04-15 02:53:18Z peter $");

#include <libyasm.h>

#include "modules/parsers/nasm/nasm-parser.h"


#define YYCURSOR        cursor
#define YYLIMIT         (s->lim)
#define YYMARKER        (s->ptr)
#define YYFILL(n)       {}

#define RETURN(i)       {s->cur = cursor; parser_nasm->tokch = s->tok[0]; \
                         return i;}

#define SCANINIT()      {s->tok = cursor;}

#define TOK             ((char *)s->tok)
#define TOKLEN          (size_t)(cursor-s->tok)


/* starting size of string buffer */
#define STRBUF_ALLOC_SIZE       128

/* string buffer used when parsing strings/character constants */
static YYCTYPE *strbuf = NULL;

/* length of strbuf (including terminating NULL character) */
static size_t strbuf_size = 0;

static int linechg_numcount;

#line 71 "./modules/parsers/nasm/nasm-token.re"


static int
handle_dot_label(YYSTYPE *lvalp, char *tok, size_t toklen, size_t zeropos,
                 yasm_parser_nasm *parser_nasm)
{
    /* check for special non-local labels like ..start */
    if (tok[zeropos+1] == '.') {
        lvalp->str_val = yasm__xstrndup(tok+zeropos, toklen-zeropos);
        /* check for special non-local ..@label */
        if (lvalp->str_val[zeropos+2] == '@')
            return NONLOCAL_ID;
        return SPECIAL_ID;
    }

    if (!parser_nasm->locallabel_base) {
        lvalp->str_val = yasm__xstrndup(tok+zeropos, toklen-zeropos);
        yasm_warn_set(YASM_WARN_GENERAL,
                      N_("no non-local label before `%s'"),
                      lvalp->str_val);
    } else {
        size_t len = toklen - zeropos + parser_nasm->locallabel_base_len;
        lvalp->str_val = yasm_xmalloc(len + 1);
        strcpy(lvalp->str_val, parser_nasm->locallabel_base);
        strncat(lvalp->str_val, tok+zeropos, toklen-zeropos);
        lvalp->str_val[len] = '\0';
    }

    return LOCAL_ID;
}

int
nasm_parser_lex(YYSTYPE *lvalp, yasm_parser_nasm *parser_nasm)
{
    yasm_scanner *s = &parser_nasm->s;
    YYCTYPE *cursor = s->cur;
    YYCTYPE endch;
    size_t count;
    YYCTYPE savech;

    /* Handle one token of lookahead */
    if (parser_nasm->peek_token != NONE) {
        int tok = parser_nasm->peek_token;
        *lvalp = parser_nasm->peek_tokval;  /* structure copy */
        parser_nasm->tokch = parser_nasm->peek_tokch;
        parser_nasm->peek_token = NONE;
        return tok;
    }

    /* Catch EOL (EOF from the scanner perspective) */
    if (s->eof && cursor == s->eof)
        return 0;

    /* Jump to proper "exclusive" states */
    switch (parser_nasm->state) {
        case DIRECTIVE:
            goto directive;
        case SECTION_DIRECTIVE:
            goto section_directive;
        case DIRECTIVE2:
            goto directive2;
        case LINECHG:
            goto linechg;
        case LINECHG2:
            goto linechg2;
        default:
            break;
    }

scan:
    SCANINIT();

    {
	static unsigned char yybm[] = {
	  0,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   3,   3,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   3,   1, 
	255, 255,  63,  63,  63,  63,  63,  63, 
	 15,  15,   1,   1,   1,   1,   1,   3, 
	  3,   7,   7,   7,   7,   7,   7,   3, 
	  3,   3,   3,   3,   3,   3,   3,   3, 
	  3,   3,   3,   3,   3,   3,   3,   3, 
	  3,   3,   3,   1,   1,   1,   1, 167, 
	  1,   7,   7,   7,   7,   7,   7,   3, 
	  3,   3,   3,   3,   3,   3,   3,   3, 
	  3,   3,   3,   3,   3,   3,   3,   3, 
	  3,   3,   3,   1,   1,   1,   3,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0, 128,   0,   0,   0, 128,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	128,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	};

#line 206 "nasm-token.c"
{
	YYCTYPE yych;
	unsigned int yyaccept;
	goto yy0;
	++YYCURSOR;
yy0:
	if((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	switch(yych){
	case '\000':	goto yy41;
	case '\t':	case '\r':	case ' ':	goto yy39;
	case '"':	case '\'':	goto yy9;
	case '$':	goto yy7;
	case '%':	goto yy11;
	case '&':	case '(':
	case ')':
	case '*':
	case '+':
	case ',':
	case '-':	case ':':	case '=':	case '[':	case '^':	case '|':	case '~':	goto yy32;
	case '.':	goto yy35;
	case '/':	goto yy31;
	case '0':	goto yy2;
	case '1':	goto yy4;
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':	goto yy5;
	case '8':
	case '9':	goto yy6;
	case ';':	goto yy37;
	case '<':	goto yy28;
	case '>':	goto yy30;
	case '?':
	case '@':	case 'C':	case 'F':
	case 'G':	case 'J':
	case 'K':	case 'M':	case 'P':	case 'U':
	case 'V':	case 'X':	case 'Z':	case '_':	case 'c':	case 'f':
	case 'g':	case 'j':
	case 'k':	case 'm':	case 'p':	case 'u':
	case 'v':	case 'x':	case 'z':	goto yy36;
	case 'A':	case 'a':	goto yy26;
	case 'B':	case 'b':	goto yy12;
	case 'D':	case 'd':	goto yy16;
	case 'E':	case 'e':	goto yy24;
	case 'H':	case 'h':	goto yy14;
	case 'I':	case 'i':	goto yy23;
	case 'L':	case 'l':	goto yy17;
	case 'N':	case 'n':	goto yy27;
	case 'O':	case 'o':	goto yy20;
	case 'Q':	case 'q':	goto yy18;
	case 'R':	case 'r':	goto yy22;
	case 'S':	case 's':	goto yy25;
	case 'T':	case 't':	goto yy19;
	case 'W':	case 'w':	goto yy15;
	case 'Y':	case 'y':	goto yy21;
	case ']':	goto yy33;
	default:	goto yy43;
	}
yy2:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 64) {
		goto yy217;
	}
	switch(yych){
	case '.':	goto yy198;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':	goto yy211;
	case '8':
	case '9':	goto yy201;
	case 'A':	case 'C':
	case 'D':
	case 'E':
	case 'F':	case 'a':	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy203;
	case 'B':	case 'b':	goto yy219;
	case 'H':	case 'h':	goto yy205;
	case 'O':	case 'Q':	case 'o':	case 'q':	goto yy215;
	case 'X':	case 'x':	goto yy223;
	case '_':	goto yy221;
	default:	goto yy3;
	}
yy3:
#line 145 "./modules/parsers/nasm/nasm-token.re"
{
            savech = s->tok[TOKLEN];
            s->tok[TOKLEN] = '\0';
            lvalp->intn = yasm_intnum_create_dec(TOK);
            s->tok[TOKLEN] = savech;
            RETURN(INTNUM);
        }
#line 308 "nasm-token.c"
yy4:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 64) {
		goto yy217;
	}
	switch(yych){
	case '.':	goto yy198;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':	goto yy211;
	case '8':
	case '9':	goto yy201;
	case 'A':	case 'C':
	case 'D':
	case 'E':
	case 'F':	case 'a':	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy203;
	case 'B':	case 'b':	goto yy219;
	case 'H':	case 'h':	goto yy205;
	case 'O':	case 'Q':	case 'o':	case 'q':	goto yy215;
	case '_':	goto yy221;
	default:	goto yy3;
	}
yy5:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 16) {
		goto yy211;
	}
	if(yych <= 'P'){
		if(yych <= '@'){
			if(yych <= '.'){
				if(yych <= '-')	goto yy3;
				goto yy198;
			} else {
				if(yych <= '/')	goto yy3;
				if(yych <= '9')	goto yy201;
				goto yy3;
			}
		} else {
			if(yych <= 'H'){
				if(yych <= 'F')	goto yy203;
				if(yych <= 'G')	goto yy3;
				goto yy205;
			} else {
				if(yych == 'O')	goto yy215;
				goto yy3;
			}
		}
	} else {
		if(yych <= 'g'){
			if(yych <= '_'){
				if(yych <= 'Q')	goto yy215;
				if(yych <= '^')	goto yy3;
				goto yy213;
			} else {
				if(yych <= '`')	goto yy3;
				if(yych <= 'f')	goto yy203;
				goto yy3;
			}
		} else {
			if(yych <= 'o'){
				if(yych <= 'h')	goto yy205;
				if(yych <= 'n')	goto yy3;
				goto yy215;
			} else {
				if(yych == 'q')	goto yy215;
				goto yy3;
			}
		}
	}
yy6:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'G'){
		if(yych <= '/'){
			if(yych == '.')	goto yy198;
			goto yy3;
		} else {
			if(yych <= '9')	goto yy201;
			if(yych <= '@')	goto yy3;
			if(yych <= 'F')	goto yy203;
			goto yy3;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'H')	goto yy205;
			if(yych == '_')	goto yy203;
			goto yy3;
		} else {
			if(yych <= 'f')	goto yy203;
			if(yych == 'h')	goto yy205;
			goto yy3;
		}
	}
yy7:	yych = *++YYCURSOR;
	if(yych <= '>'){
		if(yych <= '-'){
			if(yych <= '"')	goto yy8;
			if(yych <= '#')	goto yy189;
			if(yych <= '$')	goto yy192;
			goto yy8;
		} else {
			if(yych <= '.')	goto yy189;
			if(yych <= '/')	goto yy8;
			if(yych <= '9')	goto yy194;
			goto yy8;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy189;
			if(yych == '_')	goto yy189;
			goto yy8;
		} else {
			if(yych <= 'z')	goto yy189;
			if(yych == '~')	goto yy189;
			goto yy8;
		}
	}
yy8:
#line 326 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(s->tok[0]); }
#line 436 "nasm-token.c"
yy9:	yych = *++YYCURSOR;
	goto yy10;
yy10:
#line 198 "./modules/parsers/nasm/nasm-token.re"
{
            endch = s->tok[0];
            goto stringconst;
        }
#line 445 "nasm-token.c"
yy11:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '%')	goto yy181;
	if(yych == 'l')	goto yy183;
	goto yy8;
yy12:	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy177;
	if(yych == 'y')	goto yy177;
	goto yy49;
yy13:
#line 345 "./modules/parsers/nasm/nasm-token.re"
{
            savech = s->tok[TOKLEN];
            s->tok[TOKLEN] = '\0';
            if (parser_nasm->state != INSTRUCTION) {
                uintptr_t prefix;
                switch (yasm_arch_parse_check_insnprefix
                        (p_object->arch, TOK, TOKLEN, cur_line, &lvalp->bc,
                         &prefix)) {
                    case YASM_ARCH_INSN:
                        parser_nasm->state = INSTRUCTION;
                        s->tok[TOKLEN] = savech;
                        RETURN(INSN);
                    case YASM_ARCH_PREFIX:
                        lvalp->arch_data = prefix;
                        s->tok[TOKLEN] = savech;
                        RETURN(PREFIX);
                    default:
                        break;
                }
            }
            switch (yasm_arch_parse_check_regtmod
                    (p_object->arch, TOK, TOKLEN, &lvalp->arch_data)) {
                case YASM_ARCH_REG:
                    s->tok[TOKLEN] = savech;
                    RETURN(REG);
                case YASM_ARCH_SEGREG:
                    s->tok[TOKLEN] = savech;
                    RETURN(SEGREG);
                case YASM_ARCH_TARGETMOD:
                    s->tok[TOKLEN] = savech;
                    RETURN(TARGETMOD);
                default:
                    s->tok[TOKLEN] = savech;
            }
            /* Propagate errors in case we got a warning from the arch */
            yasm_errwarn_propagate(parser_nasm->errwarns, cur_line);
            /* Just an identifier, return as such. */
            lvalp->str_val = yasm__xstrndup(TOK, TOKLEN);
            RETURN(ID);
        }
#line 497 "nasm-token.c"
yy14:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy172;
	if(yych == 'w')	goto yy172;
	goto yy49;
yy15:	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych == 'O')	goto yy165;
		if(yych <= 'Q')	goto yy49;
		goto yy166;
	} else {
		if(yych <= 'o'){
			if(yych <= 'n')	goto yy49;
			goto yy165;
		} else {
			if(yych == 'r')	goto yy166;
			goto yy49;
		}
	}
yy16:	yych = *++YYCURSOR;
	switch(yych){
	case 'B':	case 'b':	goto yy139;
	case 'D':	case 'd':	goto yy141;
	case 'H':	case 'h':	goto yy143;
	case 'O':	case 'o':	goto yy144;
	case 'Q':	case 'q':	goto yy146;
	case 'T':	case 't':	goto yy148;
	case 'W':	case 'w':	goto yy150;
	case 'Y':	case 'y':	goto yy152;
	default:	goto yy49;
	}
yy17:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy135;
	if(yych == 'o')	goto yy135;
	goto yy49;
yy18:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy130;
	if(yych == 'w')	goto yy130;
	goto yy49;
yy19:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych == 'I')	goto yy120;
		if(yych <= 'V')	goto yy49;
		goto yy121;
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy49;
			goto yy120;
		} else {
			if(yych == 'w')	goto yy121;
			goto yy49;
		}
	}
yy20:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy115;
	if(yych == 'w')	goto yy115;
	goto yy49;
yy21:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy110;
	if(yych == 'w')	goto yy110;
	goto yy49;
yy22:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy87;
	if(yych == 'e')	goto yy87;
	goto yy49;
yy23:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy81;
	if(yych == 'n')	goto yy81;
	goto yy49;
yy24:	yych = *++YYCURSOR;
	if(yych == 'Q')	goto yy78;
	if(yych == 'q')	goto yy78;
	goto yy49;
yy25:	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych == 'E')	goto yy69;
		if(yych <= 'S')	goto yy49;
		goto yy70;
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy49;
			goto yy69;
		} else {
			if(yych == 't')	goto yy70;
			goto yy49;
		}
	}
yy26:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy66;
	if(yych == 'b')	goto yy66;
	goto yy49;
yy27:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy59;
	if(yych == 'o')	goto yy59;
	goto yy49;
yy28:	yych = *++YYCURSOR;
	if(yych == '<')	goto yy57;
	goto yy29;
yy29:
#line 395 "./modules/parsers/nasm/nasm-token.re"
{
            yasm_warn_set(YASM_WARN_UNREC_CHAR,
                          N_("ignoring unrecognized character `%s'"),
                          yasm__conv_unprint(s->tok[0]));
            goto scan;
        }
#line 603 "nasm-token.c"
yy30:	yych = *++YYCURSOR;
	if(yych == '>')	goto yy55;
	goto yy29;
yy31:	yych = *++YYCURSOR;
	if(yych == '/')	goto yy53;
	goto yy8;
yy32:	yych = *++YYCURSOR;
	goto yy8;
yy33:	yych = *++YYCURSOR;
	goto yy34;
yy34:
#line 327 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(s->tok[0]); }
#line 617 "nasm-token.c"
yy35:	yych = *++YYCURSOR;
	if(yych <= '>'){
		if(yych <= '-'){
			if(yych <= '"')	goto yy29;
			if(yych <= '$')	goto yy50;
			goto yy29;
		} else {
			if(yych == '/')	goto yy29;
			if(yych <= '9')	goto yy50;
			goto yy29;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy50;
			if(yych == '_')	goto yy50;
			goto yy29;
		} else {
			if(yych <= 'z')	goto yy50;
			if(yych == '~')	goto yy50;
			goto yy29;
		}
	}
yy36:	yych = *++YYCURSOR;
	goto yy49;
yy37:	yych = *++YYCURSOR;
	goto yy47;
yy38:
#line 386 "./modules/parsers/nasm/nasm-token.re"
{ goto scan; }
#line 647 "nasm-token.c"
yy39:	yych = *++YYCURSOR;
	goto yy45;
yy40:
#line 388 "./modules/parsers/nasm/nasm-token.re"
{ goto scan; }
#line 653 "nasm-token.c"
yy41:	yych = *++YYCURSOR;
	goto yy42;
yy42:
#line 390 "./modules/parsers/nasm/nasm-token.re"
{
            parser_nasm->state = INITIAL;
            RETURN(s->tok[0]);
        }
#line 662 "nasm-token.c"
yy43:	yych = *++YYCURSOR;
	goto yy29;
yy44:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy45;
yy45:	if(yybm[256+yych] & 128) {
		goto yy44;
	}
	goto yy40;
yy46:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy47;
yy47:	if(yybm[0+yych] & 1) {
		goto yy46;
	}
	goto yy38;
yy48:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy49;
yy49:	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy13;
yy50:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy51;
yy51:	if(yych <= '>'){
		if(yych <= '-'){
			if(yych <= '"')	goto yy52;
			if(yych <= '$')	goto yy50;
			goto yy52;
		} else {
			if(yych == '/')	goto yy52;
			if(yych <= '9')	goto yy50;
			goto yy52;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy50;
			if(yych == '_')	goto yy50;
			goto yy52;
		} else {
			if(yych <= 'z')	goto yy50;
			if(yych == '~')	goto yy50;
			goto yy52;
		}
	}
yy52:
#line 330 "./modules/parsers/nasm/nasm-token.re"
{
            RETURN(handle_dot_label(lvalp, TOK, TOKLEN, 0, parser_nasm));
        }
#line 719 "nasm-token.c"
yy53:	yych = *++YYCURSOR;
	goto yy54;
yy54:
#line 323 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(SIGNDIV); }
#line 725 "nasm-token.c"
yy55:	yych = *++YYCURSOR;
	goto yy56;
yy56:
#line 322 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(RIGHT_OP); }
#line 731 "nasm-token.c"
yy57:	yych = *++YYCURSOR;
	goto yy58;
yy58:
#line 321 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(LEFT_OP); }
#line 737 "nasm-token.c"
yy59:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy60;
	if(yych != 's')	goto yy49;
	goto yy60;
yy60:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy61;
	if(yych != 'p')	goto yy49;
	goto yy61;
yy61:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy62;
	if(yych != 'l')	goto yy49;
	goto yy62;
yy62:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy63;
	if(yych != 'i')	goto yy49;
	goto yy63;
yy63:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy64;
	if(yych != 't')	goto yy49;
	goto yy64;
yy64:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy65;
yy65:
#line 317 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(NOSPLIT); }
#line 766 "nasm-token.c"
yy66:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy67;
	if(yych != 's')	goto yy49;
	goto yy67;
yy67:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy68;
yy68:
#line 314 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(ABS); }
#line 779 "nasm-token.c"
yy69:	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy76;
	if(yych == 'g')	goto yy76;
	goto yy49;
yy70:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy71;
	if(yych != 'r')	goto yy49;
	goto yy71;
yy71:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy72;
	if(yych != 'i')	goto yy49;
	goto yy72;
yy72:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy73;
	if(yych != 'c')	goto yy49;
	goto yy73;
yy73:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy74;
	if(yych != 't')	goto yy49;
	goto yy74;
yy74:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy75;
yy75:
#line 318 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(STRICT); }
#line 808 "nasm-token.c"
yy76:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy77;
yy77:
#line 311 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(SEG); }
#line 817 "nasm-token.c"
yy78:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy79;
	if(yych != 'u')	goto yy49;
	goto yy79;
yy79:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy80;
yy80:
#line 307 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(EQU); }
#line 830 "nasm-token.c"
yy81:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy82;
	if(yych != 'c')	goto yy49;
	goto yy82;
yy82:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy83;
	if(yych != 'b')	goto yy49;
	goto yy83;
yy83:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy84;
	if(yych != 'i')	goto yy49;
	goto yy84;
yy84:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy85;
	if(yych != 'n')	goto yy49;
	goto yy85;
yy85:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy86;
yy86:
#line 305 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(INCBIN); }
#line 855 "nasm-token.c"
yy87:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'L')	goto yy89;
		if(yych <= 'R')	goto yy49;
		goto yy88;
	} else {
		if(yych <= 'l'){
			if(yych <= 'k')	goto yy49;
			goto yy89;
		} else {
			if(yych != 's')	goto yy49;
			goto yy88;
		}
	}
yy88:	yych = *++YYCURSOR;
	switch(yych){
	case 'B':	case 'b':	goto yy91;
	case 'D':	case 'd':	goto yy93;
	case 'H':	case 'h':	goto yy95;
	case 'O':	case 'o':	goto yy96;
	case 'Q':	case 'q':	goto yy98;
	case 'T':	case 't':	goto yy100;
	case 'W':	case 'w':	goto yy102;
	case 'Y':	case 'y':	goto yy104;
	default:	goto yy49;
	}
yy89:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy90;
yy90:
#line 315 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(REL); }
#line 890 "nasm-token.c"
yy91:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy92;
yy92:
#line 274 "./modules/parsers/nasm/nasm-token.re"
{ lvalp->int_info = 8; RETURN(RESERVE_SPACE); }
#line 899 "nasm-token.c"
yy93:	yych = *++YYCURSOR;
	if(yych <= 'Q'){
		if(yych <= '.'){
			if(yych <= '"')	goto yy94;
			if(yych <= '$')	goto yy48;
			if(yych >= '.')	goto yy48;
			goto yy94;
		} else {
			if(yych <= '9'){
				if(yych >= '0')	goto yy48;
				goto yy94;
			} else {
				if(yych <= '>')	goto yy94;
				if(yych <= 'P')	goto yy48;
				goto yy108;
			}
		}
	} else {
		if(yych <= 'p'){
			if(yych <= '^'){
				if(yych <= 'Z')	goto yy48;
				goto yy94;
			} else {
				if(yych != '`')	goto yy48;
				goto yy94;
			}
		} else {
			if(yych <= 'z'){
				if(yych <= 'q')	goto yy108;
				goto yy48;
			} else {
				if(yych == '~')	goto yy48;
				goto yy94;
			}
		}
	}
yy94:
#line 283 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch)*2;
            RETURN(RESERVE_SPACE);
        }
#line 942 "nasm-token.c"
yy95:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy106;
	if(yych == 'w')	goto yy106;
	goto yy49;
yy96:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy97;
yy97:
#line 296 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch)*8;
            RETURN(RESERVE_SPACE);
        }
#line 958 "nasm-token.c"
yy98:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy99;
yy99:
#line 287 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch)*4;
            RETURN(RESERVE_SPACE);
        }
#line 970 "nasm-token.c"
yy100:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy101;
yy101:
#line 291 "./modules/parsers/nasm/nasm-token.re"
{ lvalp->int_info = 80; RETURN(RESERVE_SPACE); }
#line 979 "nasm-token.c"
yy102:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy103;
yy103:
#line 279 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch);
            RETURN(RESERVE_SPACE);
        }
#line 991 "nasm-token.c"
yy104:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy105;
yy105:
#line 300 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = 256;
            RETURN(RESERVE_SPACE);
        }
#line 1003 "nasm-token.c"
yy106:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy107;
yy107:
#line 275 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch)/2;
            RETURN(RESERVE_SPACE);
        }
#line 1015 "nasm-token.c"
yy108:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy109;
yy109:
#line 292 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch)*8;
            RETURN(RESERVE_SPACE);
        }
#line 1027 "nasm-token.c"
yy110:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy111;
	if(yych != 'o')	goto yy49;
	goto yy111;
yy111:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy112;
	if(yych != 'r')	goto yy49;
	goto yy112;
yy112:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy113;
	if(yych != 'd')	goto yy49;
	goto yy113;
yy113:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy114;
yy114:
#line 237 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = 256;
            RETURN(SIZE_OVERRIDE);
        }
#line 1051 "nasm-token.c"
yy115:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy116;
	if(yych != 'o')	goto yy49;
	goto yy116;
yy116:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy117;
	if(yych != 'r')	goto yy49;
	goto yy117;
yy117:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy118;
	if(yych != 'd')	goto yy49;
	goto yy118;
yy118:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy119;
yy119:
#line 233 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch)*8;
            RETURN(SIZE_OVERRIDE);
        }
#line 1075 "nasm-token.c"
yy120:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy126;
	if(yych == 'm')	goto yy126;
	goto yy49;
yy121:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy122;
	if(yych != 'o')	goto yy49;
	goto yy122;
yy122:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy123;
	if(yych != 'r')	goto yy49;
	goto yy123;
yy123:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy124;
	if(yych != 'd')	goto yy49;
	goto yy124;
yy124:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy125;
yy125:
#line 228 "./modules/parsers/nasm/nasm-token.re"
{ lvalp->int_info = 80; RETURN(SIZE_OVERRIDE); }
#line 1100 "nasm-token.c"
yy126:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy127;
	if(yych != 'e')	goto yy49;
	goto yy127;
yy127:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy128;
	if(yych != 's')	goto yy49;
	goto yy128;
yy128:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy129;
yy129:
#line 309 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(TIMES); }
#line 1117 "nasm-token.c"
yy130:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy131;
	if(yych != 'o')	goto yy49;
	goto yy131;
yy131:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy132;
	if(yych != 'r')	goto yy49;
	goto yy132;
yy132:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy133;
	if(yych != 'd')	goto yy49;
	goto yy133;
yy133:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy134;
yy134:
#line 224 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch)*4;
            RETURN(SIZE_OVERRIDE);
        }
#line 1141 "nasm-token.c"
yy135:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy136;
	if(yych != 'n')	goto yy49;
	goto yy136;
yy136:	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy137;
	if(yych != 'g')	goto yy49;
	goto yy137;
yy137:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy138;
yy138:
#line 220 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch)*2;
            RETURN(SIZE_OVERRIDE);
        }
#line 1161 "nasm-token.c"
yy139:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy140;
yy140:
#line 243 "./modules/parsers/nasm/nasm-token.re"
{ lvalp->int_info = 8; RETURN(DECLARE_DATA); }
#line 1170 "nasm-token.c"
yy141:	yych = *++YYCURSOR;
	if(yych <= 'Q'){
		if(yych <= '.'){
			if(yych <= '"')	goto yy142;
			if(yych <= '$')	goto yy48;
			if(yych >= '.')	goto yy48;
			goto yy142;
		} else {
			if(yych <= '9'){
				if(yych >= '0')	goto yy48;
				goto yy142;
			} else {
				if(yych <= '>')	goto yy142;
				if(yych <= 'P')	goto yy48;
				goto yy163;
			}
		}
	} else {
		if(yych <= 'p'){
			if(yych <= '^'){
				if(yych <= 'Z')	goto yy48;
				goto yy142;
			} else {
				if(yych != '`')	goto yy48;
				goto yy142;
			}
		} else {
			if(yych <= 'z'){
				if(yych <= 'q')	goto yy163;
				goto yy48;
			} else {
				if(yych == '~')	goto yy48;
				goto yy142;
			}
		}
	}
yy142:
#line 252 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch)*2;
            RETURN(DECLARE_DATA);
        }
#line 1213 "nasm-token.c"
yy143:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy161;
	if(yych == 'w')	goto yy161;
	goto yy49;
yy144:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy145;
yy145:
#line 265 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch)*8;
            RETURN(DECLARE_DATA);
        }
#line 1229 "nasm-token.c"
yy146:	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= '.'){
			if(yych <= '"')	goto yy147;
			if(yych <= '$')	goto yy48;
			if(yych >= '.')	goto yy48;
			goto yy147;
		} else {
			if(yych <= '9'){
				if(yych >= '0')	goto yy48;
				goto yy147;
			} else {
				if(yych <= '>')	goto yy147;
				if(yych <= 'V')	goto yy48;
				goto yy156;
			}
		}
	} else {
		if(yych <= 'v'){
			if(yych <= '^'){
				if(yych <= 'Z')	goto yy48;
				goto yy147;
			} else {
				if(yych != '`')	goto yy48;
				goto yy147;
			}
		} else {
			if(yych <= 'z'){
				if(yych <= 'w')	goto yy156;
				goto yy48;
			} else {
				if(yych == '~')	goto yy48;
				goto yy147;
			}
		}
	}
yy147:
#line 256 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch)*4;
            RETURN(DECLARE_DATA);
        }
#line 1272 "nasm-token.c"
yy148:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy149;
yy149:
#line 260 "./modules/parsers/nasm/nasm-token.re"
{ lvalp->int_info = 80; RETURN(DECLARE_DATA); }
#line 1281 "nasm-token.c"
yy150:	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= '.'){
			if(yych <= '"')	goto yy151;
			if(yych <= '$')	goto yy48;
			if(yych >= '.')	goto yy48;
			goto yy151;
		} else {
			if(yych <= '9'){
				if(yych >= '0')	goto yy48;
				goto yy151;
			} else {
				if(yych <= '>')	goto yy151;
				if(yych <= 'N')	goto yy48;
				goto yy154;
			}
		}
	} else {
		if(yych <= 'n'){
			if(yych <= '^'){
				if(yych <= 'Z')	goto yy48;
				goto yy151;
			} else {
				if(yych != '`')	goto yy48;
				goto yy151;
			}
		} else {
			if(yych <= 'z'){
				if(yych <= 'o')	goto yy154;
				goto yy48;
			} else {
				if(yych == '~')	goto yy48;
				goto yy151;
			}
		}
	}
yy151:
#line 248 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch);
            RETURN(DECLARE_DATA);
        }
#line 1324 "nasm-token.c"
yy152:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy153;
yy153:
#line 269 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = 256;
            RETURN(DECLARE_DATA);
        }
#line 1336 "nasm-token.c"
yy154:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy155;
	if(yych != 'r')	goto yy49;
	goto yy155;
yy155:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy137;
	if(yych == 'd')	goto yy137;
	goto yy49;
yy156:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy157;
	if(yych != 'o')	goto yy49;
	goto yy157;
yy157:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy158;
	if(yych != 'r')	goto yy49;
	goto yy158;
yy158:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy159;
	if(yych != 'd')	goto yy49;
	goto yy159;
yy159:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy160;
yy160:
#line 229 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch)*8;
            RETURN(SIZE_OVERRIDE);
        }
#line 1368 "nasm-token.c"
yy161:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy162;
yy162:
#line 244 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch)/2;
            RETURN(DECLARE_DATA);
        }
#line 1380 "nasm-token.c"
yy163:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy164;
yy164:
#line 261 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch)*8;
            RETURN(DECLARE_DATA);
        }
#line 1392 "nasm-token.c"
yy165:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy169;
	if(yych == 'r')	goto yy169;
	goto yy49;
yy166:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy167;
	if(yych != 't')	goto yy49;
	goto yy167;
yy167:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy168;
yy168:
#line 312 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(WRT); }
#line 1409 "nasm-token.c"
yy169:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy170;
	if(yych != 'd')	goto yy49;
	goto yy170;
yy170:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy171;
yy171:
#line 216 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch);
            RETURN(SIZE_OVERRIDE);
        }
#line 1425 "nasm-token.c"
yy172:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy173;
	if(yych != 'o')	goto yy49;
	goto yy173;
yy173:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy174;
	if(yych != 'r')	goto yy49;
	goto yy174;
yy174:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy175;
	if(yych != 'd')	goto yy49;
	goto yy175;
yy175:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy176;
yy176:
#line 212 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->int_info = yasm_arch_wordsize(p_object->arch)/2;
            RETURN(SIZE_OVERRIDE);
        }
#line 1449 "nasm-token.c"
yy177:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy178;
	if(yych != 't')	goto yy49;
	goto yy178;
yy178:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy179;
	if(yych != 'e')	goto yy49;
	goto yy179;
yy179:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 2) {
		goto yy48;
	}
	goto yy180;
yy180:
#line 211 "./modules/parsers/nasm/nasm-token.re"
{ lvalp->int_info = 8; RETURN(SIZE_OVERRIDE); }
#line 1466 "nasm-token.c"
yy181:	yych = *++YYCURSOR;
	goto yy182;
yy182:
#line 324 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(SIGNMOD); }
#line 1472 "nasm-token.c"
yy183:	yych = *++YYCURSOR;
	if(yych == 'i')	goto yy185;
	goto yy184;
yy184:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 0:	goto yy3;
	case 3:	goto yy220;
	case 2:	goto yy200;
	case 1:	goto yy8;
	}
yy185:	yych = *++YYCURSOR;
	if(yych != 'n')	goto yy184;
	goto yy186;
yy186:	yych = *++YYCURSOR;
	if(yych != 'e')	goto yy184;
	goto yy187;
yy187:	yych = *++YYCURSOR;
	goto yy188;
yy188:
#line 204 "./modules/parsers/nasm/nasm-token.re"
{
            parser_nasm->state = LINECHG;
            linechg_numcount = 0;
            RETURN(LINE);
        }
#line 1498 "nasm-token.c"
yy189:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy190;
yy190:	if(yych <= '>'){
		if(yych <= '-'){
			if(yych <= '"')	goto yy191;
			if(yych <= '$')	goto yy189;
			goto yy191;
		} else {
			if(yych == '/')	goto yy191;
			if(yych <= '9')	goto yy189;
			goto yy191;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy189;
			if(yych == '_')	goto yy189;
			goto yy191;
		} else {
			if(yych <= 'z')	goto yy189;
			if(yych == '~')	goto yy189;
			goto yy191;
		}
	}
yy191:
#line 335 "./modules/parsers/nasm/nasm-token.re"
{
            if (TOK[1] == '.') {
                /* handle like .label */
                RETURN(handle_dot_label(lvalp, TOK, TOKLEN, 1, parser_nasm));
            }
            lvalp->str_val = yasm__xstrndup(TOK+1, TOKLEN-1);
            RETURN(ID);
        }
#line 1534 "nasm-token.c"
yy192:	yych = *++YYCURSOR;
	if(yych <= '>'){
		if(yych <= '-'){
			if(yych <= '"')	goto yy193;
			if(yych <= '$')	goto yy189;
			goto yy193;
		} else {
			if(yych == '/')	goto yy193;
			if(yych <= '9')	goto yy189;
			goto yy193;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy189;
			if(yych == '_')	goto yy189;
			goto yy193;
		} else {
			if(yych <= 'z')	goto yy189;
			if(yych == '~')	goto yy189;
			goto yy193;
		}
	}
yy193:
#line 325 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(START_SECTION_ID); }
#line 1560 "nasm-token.c"
yy194:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 4) {
		goto yy195;
	}
	goto yy190;
yy195:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy196;
yy196:	if(yybm[0+yych] & 4) {
		goto yy195;
	}
	if(yych <= '>'){
		if(yych <= '$'){
			if(yych >= '#')	goto yy189;
			goto yy197;
		} else {
			if(yych == '.')	goto yy189;
			goto yy197;
		}
	} else {
		if(yych <= 'z'){
			if(yych <= 'Z')	goto yy189;
			if(yych >= 'g')	goto yy189;
			goto yy197;
		} else {
			if(yych == '~')	goto yy189;
			goto yy197;
		}
	}
yy197:
#line 175 "./modules/parsers/nasm/nasm-token.re"
{
            savech = s->tok[TOKLEN];
            s->tok[TOKLEN] = '\0';
            if (s->tok[1] == 'x' || s->tok[1] == 'X')
                /* skip 0 and x */
                lvalp->intn = yasm_intnum_create_hex(TOK+2);
            else
                /* don't skip 0 */
                lvalp->intn = yasm_intnum_create_hex(TOK+1);
            s->tok[TOKLEN] = savech;
            RETURN(INTNUM);
        }
#line 1605 "nasm-token.c"
yy198:	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	goto yy199;
yy199:	if(yybm[0+yych] & 8) {
		goto yy198;
	}
	if(yych == 'E')	goto yy207;
	if(yych == 'e')	goto yy207;
	goto yy200;
yy200:
#line 189 "./modules/parsers/nasm/nasm-token.re"
{
            savech = s->tok[TOKLEN];
            s->tok[TOKLEN] = '\0';
            lvalp->flt = yasm_floatnum_create(TOK);
            s->tok[TOKLEN] = savech;
            RETURN(FLTNUM);
        }
#line 1626 "nasm-token.c"
yy201:	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy202;
yy202:	if(yych <= 'G'){
		if(yych <= '/'){
			if(yych == '.')	goto yy198;
			goto yy3;
		} else {
			if(yych <= '9')	goto yy201;
			if(yych <= '@')	goto yy3;
			if(yych >= 'G')	goto yy3;
			goto yy203;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'H')	goto yy205;
			if(yych != '_')	goto yy3;
			goto yy203;
		} else {
			if(yych <= 'f')	goto yy203;
			if(yych == 'h')	goto yy205;
			goto yy3;
		}
	}
yy203:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy204;
yy204:	if(yych <= 'H'){
		if(yych <= '@'){
			if(yych <= '/')	goto yy184;
			if(yych <= '9')	goto yy203;
			goto yy184;
		} else {
			if(yych <= 'F')	goto yy203;
			if(yych <= 'G')	goto yy184;
			goto yy205;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy203;
			goto yy184;
		} else {
			if(yych <= 'f')	goto yy203;
			if(yych != 'h')	goto yy184;
			goto yy205;
		}
	}
yy205:	yych = *++YYCURSOR;
	goto yy206;
yy206:
#line 168 "./modules/parsers/nasm/nasm-token.re"
{
            s->tok[TOKLEN-1] = '\0'; /* strip off 'h' */
            lvalp->intn = yasm_intnum_create_hex(TOK);
            RETURN(INTNUM);
        }
#line 1686 "nasm-token.c"
yy207:	yych = *++YYCURSOR;
	if(yych <= ','){
		if(yych != '+')	goto yy184;
		goto yy208;
	} else {
		if(yych <= '-')	goto yy208;
		if(yych <= '/')	goto yy184;
		if(yych <= '9')	goto yy209;
		goto yy184;
	}
yy208:	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy184;
	if(yych >= ':')	goto yy184;
	goto yy209;
yy209:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy210;
yy210:	if(yych <= '/')	goto yy200;
	if(yych <= '9')	goto yy209;
	goto yy200;
yy211:	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy212;
yy212:	if(yybm[0+yych] & 16) {
		goto yy211;
	}
	if(yych <= 'P'){
		if(yych <= '@'){
			if(yych <= '.'){
				if(yych <= '-')	goto yy3;
				goto yy198;
			} else {
				if(yych <= '/')	goto yy3;
				if(yych <= '9')	goto yy201;
				goto yy3;
			}
		} else {
			if(yych <= 'H'){
				if(yych <= 'F')	goto yy203;
				if(yych <= 'G')	goto yy3;
				goto yy205;
			} else {
				if(yych == 'O')	goto yy215;
				goto yy3;
			}
		}
	} else {
		if(yych <= 'g'){
			if(yych <= '_'){
				if(yych <= 'Q')	goto yy215;
				if(yych <= '^')	goto yy3;
				goto yy213;
			} else {
				if(yych <= '`')	goto yy3;
				if(yych <= 'f')	goto yy203;
				goto yy3;
			}
		} else {
			if(yych <= 'o'){
				if(yych <= 'h')	goto yy205;
				if(yych <= 'n')	goto yy3;
				goto yy215;
			} else {
				if(yych == 'q')	goto yy215;
				goto yy3;
			}
		}
	}
yy213:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy214;
yy214:	if(yybm[0+yych] & 32) {
		goto yy213;
	}
	if(yych <= 'P'){
		if(yych <= 'F'){
			if(yych <= '7')	goto yy184;
			if(yych <= '9')	goto yy203;
			if(yych <= '@')	goto yy184;
			goto yy203;
		} else {
			if(yych <= 'H'){
				if(yych <= 'G')	goto yy184;
				goto yy205;
			} else {
				if(yych != 'O')	goto yy184;
				goto yy215;
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= '`'){
				if(yych >= 'R')	goto yy184;
				goto yy215;
			} else {
				if(yych <= 'f')	goto yy203;
				if(yych <= 'g')	goto yy184;
				goto yy205;
			}
		} else {
			if(yych <= 'o'){
				if(yych <= 'n')	goto yy184;
				goto yy215;
			} else {
				if(yych != 'q')	goto yy184;
				goto yy215;
			}
		}
	}
yy215:	yych = *++YYCURSOR;
	goto yy216;
yy216:
#line 161 "./modules/parsers/nasm/nasm-token.re"
{
            s->tok[TOKLEN-1] = '\0'; /* strip off 'q' or 'o' */
            lvalp->intn = yasm_intnum_create_oct(TOK);
            RETURN(INTNUM);
        }
#line 1809 "nasm-token.c"
yy217:	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	goto yy218;
yy218:	if(yybm[0+yych] & 64) {
		goto yy217;
	}
	switch(yych){
	case '.':	goto yy198;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':	goto yy211;
	case '8':
	case '9':	goto yy201;
	case 'A':	case 'C':
	case 'D':
	case 'E':
	case 'F':	case 'a':	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy203;
	case 'B':	case 'b':	goto yy219;
	case 'H':	case 'h':	goto yy205;
	case 'O':	case 'Q':	case 'o':	case 'q':	goto yy215;
	case '_':	goto yy221;
	default:	goto yy3;
	}
yy219:	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'H'){
		if(yych <= '@'){
			if(yych <= '/')	goto yy220;
			if(yych <= '9')	goto yy203;
			goto yy220;
		} else {
			if(yych <= 'F')	goto yy203;
			if(yych >= 'H')	goto yy205;
			goto yy220;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy203;
			goto yy220;
		} else {
			if(yych <= 'f')	goto yy203;
			if(yych == 'h')	goto yy205;
			goto yy220;
		}
	}
yy220:
#line 154 "./modules/parsers/nasm/nasm-token.re"
{
            s->tok[TOKLEN-1] = '\0'; /* strip off 'b' */
            lvalp->intn = yasm_intnum_create_bin(TOK);
            RETURN(INTNUM);
        }
#line 1872 "nasm-token.c"
yy221:	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	goto yy222;
yy222:	if(yybm[0+yych] & 128) {
		goto yy221;
	}
	switch(yych){
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':	goto yy213;
	case '8':
	case '9':	case 'A':	case 'C':
	case 'D':
	case 'E':
	case 'F':	case 'a':	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy203;
	case 'B':	case 'b':	goto yy219;
	case 'H':	case 'h':	goto yy205;
	case 'O':	case 'Q':	case 'o':	case 'q':	goto yy215;
	default:	goto yy184;
	}
yy223:	yych = *++YYCURSOR;
	if(yych <= 'F'){
		if(yych <= '/')	goto yy184;
		if(yych <= '9')	goto yy224;
		if(yych <= '@')	goto yy184;
		goto yy224;
	} else {
		if(yych <= '_'){
			if(yych <= '^')	goto yy184;
			goto yy224;
		} else {
			if(yych <= '`')	goto yy184;
			if(yych >= 'g')	goto yy184;
			goto yy224;
		}
	}
yy224:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy225;
yy225:	if(yych <= 'F'){
		if(yych <= '/')	goto yy197;
		if(yych <= '9')	goto yy224;
		if(yych <= '@')	goto yy197;
		goto yy224;
	} else {
		if(yych <= '_'){
			if(yych <= '^')	goto yy197;
			goto yy224;
		} else {
			if(yych <= '`')	goto yy197;
			if(yych <= 'f')	goto yy224;
			goto yy197;
		}
	}
}
}
#line 401 "./modules/parsers/nasm/nasm-token.re"


    /* %line linenum+lineinc filename */
linechg:
    SCANINIT();

    {
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,  64,   0,   0,   0,  64,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	 64,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	};

#line 1980 "nasm-token.c"
{
	YYCTYPE yych;
	goto yy226;
	++YYCURSOR;
yy226:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych <= '\037'){
		if(yych <= '\t'){
			if(yych <= '\000')	goto yy230;
			if(yych <= '\b')	goto yy236;
			goto yy234;
		} else {
			if(yych == '\r')	goto yy234;
			goto yy236;
		}
	} else {
		if(yych <= '+'){
			if(yych <= ' ')	goto yy234;
			if(yych <= '*')	goto yy236;
			goto yy232;
		} else {
			if(yych <= '/')	goto yy236;
			if(yych >= ':')	goto yy236;
			goto yy228;
		}
	}
yy228:	yych = *++YYCURSOR;
	goto yy241;
yy229:
#line 408 "./modules/parsers/nasm/nasm-token.re"
{
            linechg_numcount++;
            savech = s->tok[TOKLEN];
            s->tok[TOKLEN] = '\0';
            lvalp->intn = yasm_intnum_create_dec(TOK);
            s->tok[TOKLEN] = savech;
            RETURN(INTNUM);
        }
#line 2020 "nasm-token.c"
yy230:	yych = *++YYCURSOR;
	goto yy231;
yy231:
#line 417 "./modules/parsers/nasm/nasm-token.re"
{
            parser_nasm->state = INITIAL;
            RETURN(s->tok[0]);
        }
#line 2029 "nasm-token.c"
yy232:	yych = *++YYCURSOR;
	goto yy233;
yy233:
#line 422 "./modules/parsers/nasm/nasm-token.re"
{
            RETURN(s->tok[0]);
        }
#line 2037 "nasm-token.c"
yy234:	yych = *++YYCURSOR;
	goto yy239;
yy235:
#line 426 "./modules/parsers/nasm/nasm-token.re"
{
            if (linechg_numcount == 2) {
                parser_nasm->state = LINECHG2;
                goto linechg2;
            }
            goto linechg;
        }
#line 2049 "nasm-token.c"
yy236:	yych = *++YYCURSOR;
	goto yy237;
yy237:
#line 434 "./modules/parsers/nasm/nasm-token.re"
{
            yasm_warn_set(YASM_WARN_UNREC_CHAR,
                          N_("ignoring unrecognized character `%s'"),
                          yasm__conv_unprint(s->tok[0]));
            goto linechg;
        }
#line 2060 "nasm-token.c"
yy238:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy239;
yy239:	if(yybm[0+yych] & 64) {
		goto yy238;
	}
	goto yy235;
yy240:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy241;
yy241:	if(yybm[0+yych] & 128) {
		goto yy240;
	}
	goto yy229;
}
}
#line 440 "./modules/parsers/nasm/nasm-token.re"


linechg2:
    SCANINIT();

    {
	static unsigned char yybm[] = {
	  0, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	};

#line 2121 "nasm-token.c"
{
	YYCTYPE yych;
	goto yy242;
	++YYCURSOR;
yy242:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych <= '\000')	goto yy244;
	if(yych == '\r')	goto yy246;
	goto yy248;
yy244:	yych = *++YYCURSOR;
	goto yy245;
yy245:
#line 446 "./modules/parsers/nasm/nasm-token.re"
{
            parser_nasm->state = INITIAL;
            RETURN(s->tok[0]);
        }
#line 2140 "nasm-token.c"
yy246:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 128) {
		goto yy248;
	}
	goto yy247;
yy247:
#line 451 "./modules/parsers/nasm/nasm-token.re"
{ }
#line 2149 "nasm-token.c"
yy248:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy249;
yy249:	if(yybm[0+yych] & 128) {
		goto yy248;
	}
	goto yy250;
yy250:
#line 453 "./modules/parsers/nasm/nasm-token.re"
{
            parser_nasm->state = LINECHG;
            lvalp->str_val = yasm__xstrndup(TOK, TOKLEN);
            RETURN(FILENAME);
        }
#line 2165 "nasm-token.c"
}
}
#line 458 "./modules/parsers/nasm/nasm-token.re"


    /* directive: [name value] */
directive:
    SCANINIT();

    {
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128,   0,   0,   0,   0,   0,   0, 
	  0, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128,   0,   0,   0,   0, 128, 
	  0, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	};

#line 2211 "nasm-token.c"
{
	YYCTYPE yych;
	goto yy251;
	++YYCURSOR;
yy251:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych <= ']'){
		if(yych <= '@'){
			if(yych >= '\001')	goto yy258;
			goto yy253;
		} else {
			if(yych <= 'Z')	goto yy256;
			if(yych <= '\\')	goto yy258;
			goto yy255;
		}
	} else {
		if(yych <= '_'){
			if(yych <= '^')	goto yy258;
			goto yy256;
		} else {
			if(yych <= '`')	goto yy258;
			if(yych <= 'z')	goto yy256;
			goto yy258;
		}
	}
yy253:	yych = *++YYCURSOR;
	goto yy254;
yy254:
#line 465 "./modules/parsers/nasm/nasm-token.re"
{
            parser_nasm->state = INITIAL;
            RETURN(s->tok[0]);
        }
#line 2246 "nasm-token.c"
yy255:	yych = *++YYCURSOR;
	goto yy254;
yy256:	yych = *++YYCURSOR;
	goto yy261;
yy257:
#line 470 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->str_val = yasm__xstrndup(TOK, TOKLEN);
            if (yasm__strcasecmp(lvalp->str_val, "section") == 0 ||
                yasm__strcasecmp(lvalp->str_val, "segment") == 0)
                parser_nasm->state = SECTION_DIRECTIVE;
            else
                parser_nasm->state = DIRECTIVE2;
            RETURN(DIRECTIVE_NAME);
        }
#line 2262 "nasm-token.c"
yy258:	yych = *++YYCURSOR;
	goto yy259;
yy259:
#line 480 "./modules/parsers/nasm/nasm-token.re"
{
            yasm_warn_set(YASM_WARN_UNREC_CHAR,
                          N_("ignoring unrecognized character `%s'"),
                          yasm__conv_unprint(s->tok[0]));
            goto directive;
        }
#line 2273 "nasm-token.c"
yy260:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy261;
yy261:	if(yybm[0+yych] & 128) {
		goto yy260;
	}
	goto yy257;
}
}
#line 486 "./modules/parsers/nasm/nasm-token.re"


    /* section directive (the section name portion thereof) */
section_directive:
    SCANINIT();

    {
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,  64,   0,   0,   0,  64,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	 64,   0,   0, 128, 128,   0,   0,   0, 
	  0,   0,   0,   0,   0, 128, 128,   0, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128,   0,   0,   0,   0,   0, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128,   0,   0,   0,   0, 128, 
	  0, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128,   0,   0,   0, 128,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	};

#line 2327 "nasm-token.c"
{
	YYCTYPE yych;
	goto yy262;
	++YYCURSOR;
yy262:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych <= ','){
		if(yych <= '\037'){
			if(yych <= '\t'){
				if(yych <= '\000')	goto yy272;
				if(yych <= '\b')	goto yy274;
				goto yy268;
			} else {
				if(yych == '\r')	goto yy268;
				goto yy274;
			}
		} else {
			if(yych <= '"'){
				if(yych <= ' ')	goto yy268;
				if(yych <= '!')	goto yy274;
				goto yy266;
			} else {
				if(yych <= '$')	goto yy264;
				if(yych == '\'')	goto yy266;
				goto yy274;
			}
		}
	} else {
		if(yych <= ']'){
			if(yych <= '9'){
				if(yych == '/')	goto yy274;
				goto yy264;
			} else {
				if(yych <= '>')	goto yy274;
				if(yych <= 'Z')	goto yy264;
				if(yych <= '\\')	goto yy274;
				goto yy270;
			}
		} else {
			if(yych <= '`'){
				if(yych != '_')	goto yy274;
				goto yy264;
			} else {
				if(yych <= 'z')	goto yy264;
				if(yych != '~')	goto yy274;
				goto yy264;
			}
		}
	}
yy264:	yych = *++YYCURSOR;
	goto yy279;
yy265:
#line 493 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->str.contents = yasm__xstrndup(TOK, TOKLEN);
            lvalp->str.len = TOKLEN;
            parser_nasm->state = DIRECTIVE2;
            RETURN(STRING);
        }
#line 2388 "nasm-token.c"
yy266:	yych = *++YYCURSOR;
	goto yy267;
yy267:
#line 500 "./modules/parsers/nasm/nasm-token.re"
{
            parser_nasm->state = DIRECTIVE2;
            endch = s->tok[0];
            goto stringconst;
        }
#line 2398 "nasm-token.c"
yy268:	yych = *++YYCURSOR;
	goto yy277;
yy269:
#line 506 "./modules/parsers/nasm/nasm-token.re"
{
            parser_nasm->state = DIRECTIVE2;
            goto section_directive;
        }
#line 2407 "nasm-token.c"
yy270:	yych = *++YYCURSOR;
	goto yy271;
yy271:
#line 511 "./modules/parsers/nasm/nasm-token.re"
{
            parser_nasm->state = INITIAL;
            RETURN(s->tok[0]);
        }
#line 2416 "nasm-token.c"
yy272:	yych = *++YYCURSOR;
	goto yy273;
yy273:
#line 516 "./modules/parsers/nasm/nasm-token.re"
{
            parser_nasm->state = INITIAL;
            RETURN(s->tok[0]);
        }
#line 2425 "nasm-token.c"
yy274:	yych = *++YYCURSOR;
	goto yy275;
yy275:
#line 521 "./modules/parsers/nasm/nasm-token.re"
{
            yasm_warn_set(YASM_WARN_UNREC_CHAR,
                          N_("ignoring unrecognized character `%s'"),
                          yasm__conv_unprint(s->tok[0]));
            goto section_directive;
        }
#line 2436 "nasm-token.c"
yy276:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy277;
yy277:	if(yybm[0+yych] & 64) {
		goto yy276;
	}
	goto yy269;
yy278:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy279;
yy279:	if(yybm[0+yych] & 128) {
		goto yy278;
	}
	goto yy265;
}
}
#line 527 "./modules/parsers/nasm/nasm-token.re"


    /* inner part of directive */
directive2:
    SCANINIT();

    {
	static unsigned char yybm[] = {
	  0,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   3,   3,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   3,   1, 
	255, 255,  63,  63,  63,  63,  63,  63, 
	 15,  15,   1,   1,   1,   1,   1,   3, 
	  3,   7,   7,   7,   7,   7,   7,   3, 
	  3,   3,   3,   3,   3,   3,   3,   3, 
	  3,   3,   3,   3,   3,   3,   3,   3, 
	  3,   3,   3,   1,   1,   1,   1, 167, 
	  1,   7,   7,   7,   7,   7,   7,   3, 
	  3,   3,   3,   3,   3,   3,   3,   3, 
	  3,   3,   3,   3,   3,   3,   3,   3, 
	  3,   3,   3,   1,   1,   1,   3,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  1,   1,   1,   1,   1,   1,   1,   1, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0, 128,   0,   0,   0, 128,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	128,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	};

#line 2530 "nasm-token.c"
{
	YYCTYPE yych;
	unsigned int yyaccept;
	goto yy280;
	++YYCURSOR;
yy280:
	if((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if(yych <= '7'){
		if(yych <= '#'){
			if(yych <= '\r'){
				if(yych <= '\b'){
					if(yych <= '\000')	goto yy305;
					goto yy307;
				} else {
					if(yych <= '\t')	goto yy303;
					if(yych <= '\f')	goto yy307;
					goto yy303;
				}
			} else {
				if(yych <= ' '){
					if(yych <= '\037')	goto yy307;
					goto yy303;
				} else {
					if(yych == '"')	goto yy289;
					goto yy307;
				}
			}
		} else {
			if(yych <= '-'){
				if(yych <= '%'){
					if(yych <= '$')	goto yy287;
					goto yy295;
				} else {
					if(yych == '\'')	goto yy289;
					goto yy296;
				}
			} else {
				if(yych <= '/'){
					if(yych <= '.')	goto yy299;
					goto yy294;
				} else {
					if(yych <= '0')	goto yy282;
					if(yych <= '1')	goto yy284;
					goto yy285;
				}
			}
		}
	} else {
		if(yych <= '['){
			if(yych <= '='){
				if(yych <= ':'){
					if(yych <= '9')	goto yy286;
					goto yy296;
				} else {
					if(yych <= ';')	goto yy301;
					if(yych <= '<')	goto yy291;
					goto yy296;
				}
			} else {
				if(yych <= '?'){
					if(yych <= '>')	goto yy293;
					goto yy299;
				} else {
					if(yych <= '@')	goto yy307;
					if(yych <= 'Z')	goto yy299;
					goto yy296;
				}
			}
		} else {
			if(yych <= '`'){
				if(yych <= ']'){
					if(yych <= '\\')	goto yy307;
					goto yy297;
				} else {
					if(yych <= '^')	goto yy296;
					if(yych <= '_')	goto yy299;
					goto yy307;
				}
			} else {
				if(yych <= '|'){
					if(yych <= 'z')	goto yy299;
					if(yych <= '{')	goto yy307;
					goto yy296;
				} else {
					if(yych == '~')	goto yy296;
					goto yy307;
				}
			}
		}
	}
yy282:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'X')	goto yy348;
	if(yych == 'x')	goto yy348;
	goto yy343;
yy283:
#line 535 "./modules/parsers/nasm/nasm-token.re"
{
            savech = s->tok[TOKLEN];
            s->tok[TOKLEN] = '\0';
            lvalp->intn = yasm_intnum_create_dec(TOK);
            s->tok[TOKLEN] = savech;
            RETURN(INTNUM);
        }
#line 2636 "nasm-token.c"
yy284:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy343;
yy285:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy337;
yy286:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy330;
yy287:	yych = *++YYCURSOR;
	if(yych <= '>'){
		if(yych <= '-'){
			if(yych <= '"')	goto yy288;
			if(yych <= '$')	goto yy322;
			goto yy288;
		} else {
			if(yych <= '.')	goto yy322;
			if(yych <= '/')	goto yy288;
			if(yych <= '9')	goto yy325;
			goto yy288;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy322;
			if(yych == '_')	goto yy322;
			goto yy288;
		} else {
			if(yych <= 'z')	goto yy322;
			if(yych == '~')	goto yy322;
			goto yy288;
		}
	}
yy288:
#line 589 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(s->tok[0]); }
#line 2672 "nasm-token.c"
yy289:	yych = *++YYCURSOR;
	goto yy290;
yy290:
#line 579 "./modules/parsers/nasm/nasm-token.re"
{
            endch = s->tok[0];
            goto stringconst;
        }
#line 2681 "nasm-token.c"
yy291:	yych = *++YYCURSOR;
	if(yych == '<')	goto yy320;
	goto yy292;
yy292:
#line 633 "./modules/parsers/nasm/nasm-token.re"
{
            yasm_warn_set(YASM_WARN_UNREC_CHAR,
                          N_("ignoring unrecognized character `%s'"),
                          yasm__conv_unprint(s->tok[0]));
            goto scan;
        }
#line 2693 "nasm-token.c"
yy293:	yych = *++YYCURSOR;
	if(yych == '>')	goto yy318;
	goto yy292;
yy294:	yych = *++YYCURSOR;
	if(yych == '/')	goto yy316;
	goto yy288;
yy295:	yych = *++YYCURSOR;
	if(yych == '%')	goto yy314;
	goto yy288;
yy296:	yych = *++YYCURSOR;
	goto yy288;
yy297:	yych = *++YYCURSOR;
	goto yy298;
yy298:
#line 592 "./modules/parsers/nasm/nasm-token.re"
{
            parser_nasm->state = INITIAL;
            RETURN(s->tok[0]);
        }
#line 2713 "nasm-token.c"
yy299:	yych = *++YYCURSOR;
	goto yy313;
yy300:
#line 606 "./modules/parsers/nasm/nasm-token.re"
{
            savech = s->tok[TOKLEN];
            s->tok[TOKLEN] = '\0';
            switch (yasm_arch_parse_check_regtmod
                    (p_object->arch, TOK, TOKLEN, &lvalp->arch_data)) {
                case YASM_ARCH_REG:
                    s->tok[TOKLEN] = savech;
                    RETURN(REG);
                default:
                    s->tok[TOKLEN] = savech;
            }
            /* Propagate errors in case we got a warning from the arch */
            yasm_errwarn_propagate(parser_nasm->errwarns, cur_line);
            /* Just an identifier, return as such. */
            lvalp->str_val = yasm__xstrndup(TOK, TOKLEN);
            RETURN(ID);
        }
#line 2735 "nasm-token.c"
yy301:	yych = *++YYCURSOR;
	goto yy311;
yy302:
#line 624 "./modules/parsers/nasm/nasm-token.re"
{ goto directive2; }
#line 2741 "nasm-token.c"
yy303:	yych = *++YYCURSOR;
	goto yy309;
yy304:
#line 626 "./modules/parsers/nasm/nasm-token.re"
{ goto directive2; }
#line 2747 "nasm-token.c"
yy305:	yych = *++YYCURSOR;
	goto yy306;
yy306:
#line 628 "./modules/parsers/nasm/nasm-token.re"
{
            parser_nasm->state = INITIAL;
            RETURN(s->tok[0]);
        }
#line 2756 "nasm-token.c"
yy307:	yych = *++YYCURSOR;
	goto yy292;
yy308:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy309;
yy309:	if(yybm[256+yych] & 128) {
		goto yy308;
	}
	goto yy304;
yy310:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy311;
yy311:	if(yybm[0+yych] & 1) {
		goto yy310;
	}
	goto yy302;
yy312:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy313;
yy313:	if(yybm[0+yych] & 2) {
		goto yy312;
	}
	goto yy300;
yy314:	yych = *++YYCURSOR;
	goto yy315;
yy315:
#line 588 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(SIGNMOD); }
#line 2788 "nasm-token.c"
yy316:	yych = *++YYCURSOR;
	goto yy317;
yy317:
#line 587 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(SIGNDIV); }
#line 2794 "nasm-token.c"
yy318:	yych = *++YYCURSOR;
	goto yy319;
yy319:
#line 586 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(RIGHT_OP); }
#line 2800 "nasm-token.c"
yy320:	yych = *++YYCURSOR;
	goto yy321;
yy321:
#line 585 "./modules/parsers/nasm/nasm-token.re"
{ RETURN(LEFT_OP); }
#line 2806 "nasm-token.c"
yy322:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy323;
yy323:	if(yych <= '>'){
		if(yych <= '-'){
			if(yych <= '"')	goto yy324;
			if(yych <= '$')	goto yy322;
			goto yy324;
		} else {
			if(yych == '/')	goto yy324;
			if(yych <= '9')	goto yy322;
			goto yy324;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy322;
			if(yych == '_')	goto yy322;
			goto yy324;
		} else {
			if(yych <= 'z')	goto yy322;
			if(yych == '~')	goto yy322;
			goto yy324;
		}
	}
yy324:
#line 600 "./modules/parsers/nasm/nasm-token.re"
{
            lvalp->str_val = yasm__xstrndup(TOK, TOKLEN);
            RETURN(ID);
        }
#line 2838 "nasm-token.c"
yy325:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 4) {
		goto yy326;
	}
	goto yy323;
yy326:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy327;
yy327:	if(yybm[0+yych] & 4) {
		goto yy326;
	}
	if(yych <= '>'){
		if(yych <= '$'){
			if(yych >= '#')	goto yy322;
			goto yy328;
		} else {
			if(yych == '.')	goto yy322;
			goto yy328;
		}
	} else {
		if(yych <= 'z'){
			if(yych <= 'Z')	goto yy322;
			if(yych >= 'g')	goto yy322;
			goto yy328;
		} else {
			if(yych == '~')	goto yy322;
			goto yy328;
		}
	}
yy328:
#line 565 "./modules/parsers/nasm/nasm-token.re"
{
            savech = s->tok[TOKLEN];
            s->tok[TOKLEN] = '\0';
            if (s->tok[1] == 'x' || s->tok[1] == 'X')
                /* skip 0 and x */
                lvalp->intn = yasm_intnum_create_hex(TOK+2);
            else
                /* don't skip 0 */
                lvalp->intn = yasm_intnum_create_hex(TOK+1);
            s->tok[TOKLEN] = savech;
            RETURN(INTNUM);
        }
#line 2883 "nasm-token.c"
yy329:	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy330;
yy330:	if(yybm[0+yych] & 8) {
		goto yy329;
	}
	if(yych <= '^'){
		if(yych <= 'F'){
			if(yych <= '@')	goto yy283;
			goto yy331;
		} else {
			if(yych == 'H')	goto yy334;
			goto yy283;
		}
	} else {
		if(yych <= 'f'){
			if(yych == '`')	goto yy283;
			goto yy331;
		} else {
			if(yych == 'h')	goto yy334;
			goto yy283;
		}
	}
yy331:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy332;
yy332:	if(yych <= 'H'){
		if(yych <= '@'){
			if(yych <= '/')	goto yy333;
			if(yych <= '9')	goto yy331;
			goto yy333;
		} else {
			if(yych <= 'F')	goto yy331;
			if(yych >= 'H')	goto yy334;
			goto yy333;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy331;
			goto yy333;
		} else {
			if(yych <= 'f')	goto yy331;
			if(yych == 'h')	goto yy334;
			goto yy333;
		}
	}
yy333:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 0:	goto yy283;
	case 1:	goto yy345;
	}
yy334:	yych = *++YYCURSOR;
	goto yy335;
yy335:
#line 558 "./modules/parsers/nasm/nasm-token.re"
{
            s->tok[TOKLEN-1] = '\0'; /* strip off 'h' */
            lvalp->intn = yasm_intnum_create_hex(TOK);
            RETURN(INTNUM);
        }
#line 2947 "nasm-token.c"
yy336:	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy337;
yy337:	if(yybm[0+yych] & 16) {
		goto yy336;
	}
	if(yych <= 'Q'){
		if(yych <= 'G'){
			if(yych <= '9'){
				if(yych <= '7')	goto yy283;
				goto yy329;
			} else {
				if(yych <= '@')	goto yy283;
				if(yych <= 'F')	goto yy331;
				goto yy283;
			}
		} else {
			if(yych <= 'N'){
				if(yych <= 'H')	goto yy334;
				goto yy283;
			} else {
				if(yych == 'P')	goto yy283;
				goto yy340;
			}
		}
	} else {
		if(yych <= 'g'){
			if(yych <= '_'){
				if(yych <= '^')	goto yy283;
				goto yy338;
			} else {
				if(yych <= '`')	goto yy283;
				if(yych <= 'f')	goto yy331;
				goto yy283;
			}
		} else {
			if(yych <= 'o'){
				if(yych <= 'h')	goto yy334;
				if(yych <= 'n')	goto yy283;
				goto yy340;
			} else {
				if(yych == 'q')	goto yy340;
				goto yy283;
			}
		}
	}
yy338:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy339;
yy339:	if(yybm[0+yych] & 32) {
		goto yy338;
	}
	if(yych <= 'P'){
		if(yych <= 'F'){
			if(yych <= '7')	goto yy333;
			if(yych <= '9')	goto yy331;
			if(yych <= '@')	goto yy333;
			goto yy331;
		} else {
			if(yych <= 'H'){
				if(yych <= 'G')	goto yy333;
				goto yy334;
			} else {
				if(yych != 'O')	goto yy333;
				goto yy340;
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= '`'){
				if(yych >= 'R')	goto yy333;
				goto yy340;
			} else {
				if(yych <= 'f')	goto yy331;
				if(yych <= 'g')	goto yy333;
				goto yy334;
			}
		} else {
			if(yych <= 'o'){
				if(yych <= 'n')	goto yy333;
				goto yy340;
			} else {
				if(yych != 'q')	goto yy333;
				goto yy340;
			}
		}
	}
yy340:	yych = *++YYCURSOR;
	goto yy341;
yy341:
#line 551 "./modules/parsers/nasm/nasm-token.re"
{
            s->tok[TOKLEN-1] = '\0'; /* strip off 'q' or 'o' */
            lvalp->intn = yasm_intnum_create_oct(TOK);
            RETURN(INTNUM);
        }
#line 3047 "nasm-token.c"
yy342:	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	goto yy343;
yy343:	if(yybm[0+yych] & 64) {
		goto yy342;
	}
	switch(yych){
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':	goto yy336;
	case '8':
	case '9':	goto yy329;
	case 'A':	case 'C':
	case 'D':
	case 'E':
	case 'F':	case 'a':	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy331;
	case 'B':	case 'b':	goto yy344;
	case 'H':	case 'h':	goto yy334;
	case 'O':	case 'Q':	case 'o':	case 'q':	goto yy340;
	case '_':	goto yy346;
	default:	goto yy283;
	}
yy344:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'H'){
		if(yych <= '@'){
			if(yych <= '/')	goto yy345;
			if(yych <= '9')	goto yy331;
			goto yy345;
		} else {
			if(yych <= 'F')	goto yy331;
			if(yych >= 'H')	goto yy334;
			goto yy345;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy331;
			goto yy345;
		} else {
			if(yych <= 'f')	goto yy331;
			if(yych == 'h')	goto yy334;
			goto yy345;
		}
	}
yy345:
#line 544 "./modules/parsers/nasm/nasm-token.re"
{
            s->tok[TOKLEN-1] = '\0'; /* strip off 'b' */
            lvalp->intn = yasm_intnum_create_bin(TOK);
            RETURN(INTNUM);
        }
#line 3107 "nasm-token.c"
yy346:	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	goto yy347;
yy347:	if(yybm[0+yych] & 128) {
		goto yy346;
	}
	switch(yych){
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':	goto yy338;
	case '8':
	case '9':	case 'A':	case 'C':
	case 'D':
	case 'E':
	case 'F':	case 'a':	case 'c':
	case 'd':
	case 'e':
	case 'f':	goto yy331;
	case 'B':	case 'b':	goto yy344;
	case 'H':	case 'h':	goto yy334;
	case 'O':	case 'Q':	case 'o':	case 'q':	goto yy340;
	default:	goto yy333;
	}
yy348:	yych = *++YYCURSOR;
	if(yych <= 'F'){
		if(yych <= '/')	goto yy333;
		if(yych <= '9')	goto yy349;
		if(yych <= '@')	goto yy333;
		goto yy349;
	} else {
		if(yych <= '_'){
			if(yych <= '^')	goto yy333;
			goto yy349;
		} else {
			if(yych <= '`')	goto yy333;
			if(yych >= 'g')	goto yy333;
			goto yy349;
		}
	}
yy349:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy350;
yy350:	if(yych <= 'F'){
		if(yych <= '/')	goto yy328;
		if(yych <= '9')	goto yy349;
		if(yych <= '@')	goto yy328;
		goto yy349;
	} else {
		if(yych <= '_'){
			if(yych <= '^')	goto yy328;
			goto yy349;
		} else {
			if(yych <= '`')	goto yy328;
			if(yych <= 'f')	goto yy349;
			goto yy328;
		}
	}
}
}
#line 639 "./modules/parsers/nasm/nasm-token.re"


    /* string/character constant values */
stringconst:
    strbuf = yasm_xmalloc(STRBUF_ALLOC_SIZE);
    strbuf_size = STRBUF_ALLOC_SIZE;
    count = 0;

stringconst_scan:
    SCANINIT();

    {

#line 3186 "nasm-token.c"
{
	YYCTYPE yych;
	goto yy351;
	++YYCURSOR;
yy351:
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych >= '\001')	goto yy355;
	goto yy353;
yy353:	yych = *++YYCURSOR;
	goto yy354;
yy354:
#line 651 "./modules/parsers/nasm/nasm-token.re"
{
            yasm_error_set(YASM_ERROR_SYNTAX, N_("unterminated string"));
            strbuf[count] = '\0';
            lvalp->str.contents = (char *)strbuf;
            lvalp->str.len = count;
            RETURN(STRING);
        }
#line 3207 "nasm-token.c"
yy355:	yych = *++YYCURSOR;
	goto yy356;
yy356:
#line 659 "./modules/parsers/nasm/nasm-token.re"
{
            if (s->tok[0] == endch) {
                strbuf[count] = '\0';
                lvalp->str.contents = (char *)strbuf;
                lvalp->str.len = count;
                RETURN(STRING);
            }

            strbuf[count++] = s->tok[0];
            if (count >= strbuf_size) {
                strbuf = yasm_xrealloc(strbuf, strbuf_size + STRBUF_ALLOC_SIZE);
                strbuf_size += STRBUF_ALLOC_SIZE;
            }

            goto stringconst_scan;
        }
#line 3228 "nasm-token.c"
}
}
#line 675 "./modules/parsers/nasm/nasm-token.re"

}
